<?php
/**
 * Base: wpdmpro
 * Developer: shahjada
 * Team: W3 Eden
 * Date: 2/2/20 18:24
 */

if(!defined("ABSPATH")) die();
?>

<div class="w3eden">
    <div id="wpdmpm-chat-panel">
        <div class="card __hide animated">
            <div class="card-header">
                <a class="float-right close-wpdmpm-chat c-pointer" ><i class="fa fa-times-circle"></i></a>
                <div><i class="fas fa-comment-dots"></i> <?php _e('Welcome Back', PM_TEXT_DOMAIN); ?></div>
            </div>
            <div class="card-body p-0 list-group list-group-flush" id="__chat_wpdmpm">

                <div class="list-group-item p-0" v-for="message in messages">
                    <div class="media p-3"  v-if="message.type === 'user'">
                        <div class="mr-3"><img style="width: 32px;height: 32px" v-bind:src="message.sender_pic" class="msg-sender"/></div>
                        <div class="media-body">
                            <strong class="d-block text-secondary">{{ message.sender_name }}:</strong>
                            <span v-html="message.body"></span>
                        </div>
                    </div>
                    <div class="media bg-light p-3" v-else>
                        <div class="mr-3"><img style="width: 32px;height: 32px" v-bind:src="message.sender_pic" class="msg-sender"/></div>
                        <div class="media-body">
                            <strong class="d-block text-primary">{{ message.sender_name }}:</strong>
                            <span v-html="message.body"></span>
                        </div>
                    </div>
                </div>


            </div>
            <div class="card-footer bg-white">
                <form method="post" id="wpdmpm-send-chat">
                    <div class="input-group">
                        <?php if(PrivateMessage()->settings->general->multiline_msg) { ?>
                            <textarea  class="form-control border-0"  placeholder="<?php echo is_user_logged_in() ? __('Write something...', 'wpdm-premium-packages') : __('Your email', 'wpdm-premium-packages');  ?>" type="text" id="__message" name="message"></textarea>
                        <?php } else { ?>
                            <input type="text" class="form-control border-0"  placeholder="<?php echo is_user_logged_in() ? __('Write something...', 'wpdm-premium-packages') : __('Your email', 'wpdm-premium-packages');  ?>" type="text" id="__message" name="message" />
                        <?php } ?><div class="input-group-append">
                            <button type="submit" class="btn btn-info"><i class="fa fa-paper-plane"></i></button>
                        </div>
                    </div>
                </form>
            </div>
        </div>
    </div>
    <svg id="wpdmpm-trigger" style="padding: 5px;background: #2995ec" enable-background="new 0 0 256 256" height="56px" version="1.1" viewBox="0 0 256 256" width="56px" xml:space="preserve" xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink"><g id="Layer_1"><circle cx="128" cy="128" fill="#2995ec" r="128"/></g><g id="Layer_3"><path d="M146.75,69.22h-100c-6.903,0-12.5,5.596-12.5,12.5v58.333c0,6.903,5.597,12.501,12.5,12.501h7.759h0.862   v17.297l22.844-17.297h68.536c6.902,0,12.5-5.598,12.5-12.501V81.72C159.25,74.816,153.652,69.22,146.75,69.22z" fill="#084049"/></g><g id="Layer_2"><path d="M209.25,110.703h-100c-6.903,0-12.5,5.596-12.5,12.5v58.334c0,6.902,5.597,12.5,12.5,12.5h5.604   l22.844,17.297v-17.297h71.553c6.902,0,12.5-5.598,12.5-12.5v-58.334C221.75,116.299,216.152,110.703,209.25,110.703z" fill="#F9F9FA"/></g><g id="Layer_4"><circle cx="129.509" cy="152.555" fill="#2995ec" r="10"/><circle cx="159.681" cy="152.555" fill="#2995ec" r="10"/><circle cx="188.99" cy="152.555" fill="#2995ec" r="10"/></g></svg>
</div>
<style>
    #wpdmpm-chat-panel .card{
        position: fixed;
        width: 350px;
        height: 500px;
        right: 20px;
        bottom: 20px;
        border-radius: 6px !important;
        overflow: hidden;
        border:0;
        box-shadow: 0 0 15px rgba(0,0,0,0.1) !important;
        z-index: 99999999999;
    }
    .__hide{
        display: none !important;
    }
    #__chat_wpdmpm{
        font-size: 13px;
        height: calc(100% - 108px);
        overflow: auto;
    }
    #wpdmpm-send-chat .btn {
        border-radius: 500px !important;
        width: 38px;
        padding: 0;
        line-height: 38px;
        height: 38px;
        font-size: 12px;
    }
    #wpdmpm-chat-panel .card .card-header{
        background: #7556ff;
        color: #ffffff;
    }
    .animated {
        -webkit-animation-duration: 1s;
        animation-duration: 1s;
        -webkit-animation-fill-mode: both;
        animation-fill-mode: both;
    }
    @keyframes fadeInRight {
        from {
            opacity: 0;
            -webkit-transform: translate3d(100%, 0, 0);
            transform: translate3d(100%, 0, 0);
        }

        to {
            opacity: 1;
            -webkit-transform: translate3d(0, 0, 0);
            transform: translate3d(0, 0, 0);
        }
    }

    .fadeInRight {
        -webkit-animation-name: fadeInRight;
        animation-name: fadeInRight;
    }
    @keyframes fadeOutRight {
        from {
            opacity: 1;
        }

        to {
            opacity: 0;
            -webkit-transform: translate3d(100%, 0, 0);
            transform: translate3d(100%, 0, 0);
        }
    }

    .fadeOutRight {
        -webkit-animation-name: fadeOutRight;
        animation-name: fadeOutRight;
    }

</style>
<script>
    jQuery(function ($) {
        $('#wpdmpm-trigger').on('click', function () {
            $('#wpdmpm-chat-panel .card').removeClass('__hide fadeOutRight').addClass('fadeInRight');
            $.ajax(wpdmpmAPI.chat_id,{
                method: 'GET',
                beforeSend: function (xhr) {
                    xhr.setRequestHeader( 'X-WP-Nonce', wpdmpmAPI.nonce );
                }
            }).done(function (response) {
                localStorage.setItem("wpdmpm_chat_id", response.chat_id);
                __check = 1;
                $.get(chat_path+response.chat_id+'.json', function (response, status, xhr) {
                    if(__dcount < response.data.length) {
                        __dcount = response.data.length;
                        __chat.messages = [greet];
                        __chat.messages = __chat.messages.concat(response.data);
                    }
                });
            });
        });
        $('.close-wpdmpm-chat').on('click', function () {
            $('#wpdmpm-chat-panel .card').removeClass('fadeInRight').addClass('fadeOutRight');
            __check = 0;
        });
    });
</script>


