<?php

/**
 * Base: wpdmpro
 * Developer: shahjada
 * Team: W3 Eden
 * Date: 2/2/20 18:24
 */

if(!defined("ABSPATH")) die();
?>

<div class="w3eden">
    <div id="wpdmpm-chat-panel">
        <div class="card">
            <div class="card-header text-white" style="background: var(--color-primary);">
                <div><i class="fas fa-comment-dots"></i> <?php _e('Welcome Back', PM_TEXT_DOMAIN); ?></div>
            </div>
            <div class="card-body p-0 list-group list-group-flush" id="__chat_wpdmpm">

                <div class="list-group-item p-0" v-for="message in messages">
                    <div class="media p-3"  v-if="message.type === 'user'">
                        <div class="mr-3"><img style="width: 32px;height: 32px" v-bind:src="message.sender_pic" class="msg-sender"/></div>
                        <div class="media-body">
                            <strong class="d-block text-secondary">{{ message.sender_name }}:</strong>
                            <span class="msg-body" v-html="message.body"></span>
                        </div>
                    </div>
                    <div class="media bg-light p-3" v-else>
                        <div class="mr-3"><img style="width: 32px;height: 32px" v-bind:src="message.sender_pic" class="msg-sender"/></div>
                        <div class="media-body">
                            <strong class="d-block text-primary">{{ message.sender_name }}:</strong>
                            <span class="msg-body" v-html="message.body"></span>
                        </div>
                    </div>
                </div>


            </div>
            <div class="card-footer bg-white">
                <form method="post" id="wpdmpm-send-chat">
                    <div class="input-group input-group-lg">
                        <?php if(PrivateMessage()->settings->general->multiline_msg) { ?>
                            <textarea  class="form-control border-0"  placeholder="<?php echo is_user_logged_in() ? __('Write something...', 'wpdm-premium-packages') : __('Your email', 'wpdm-premium-packages');  ?>" type="text" id="__message" name="message"></textarea>
                        <?php } else { ?>
                            <input type="text" class="form-control border-0"  placeholder="<?php echo is_user_logged_in() ? __('Write something...', 'wpdm-premium-packages') : __('Your email', 'wpdm-premium-packages');  ?>" type="text" id="__message" name="message" />
                        <?php } ?><div class="input-group-append">
                            <button type="submit" class="btn btn-primary"><i class="fa fa-paper-plane"></i> <?php _e('Send', PM_TEXT_DOMAIN); ?></button>
                        </div>
                    </div>
                </form>
            </div>
        </div>
    </div>
</div>
<style>
    #wpdmpm-chat-panel{
        z-index: 1 !important;
    }
    #wpdmpm-chat-panel .card{
        height: 500px;
        position: relative;
        border: 0;
        border-radius: 4px !important;
        overflow: hidden;
        box-shadow: 0 0 15px rgba(0,0,0,0.1) !important;
        z-index: 10;
    }

    #__chat_wpdmpm{
        font-size: 13px;
        height: calc(100% - 108px);
        overflow: auto;
    }
    #wpdmpm-send-chat .form-control,
    #wpdmpm-send-chat .btn {
        border-radius: 3px !important;
        border: 0;
        padding: 0 25px;
        line-height: 48px;
        height: 48px;
        font-size: 14px;
    }


</style>
<script>
    jQuery(function ($) {
        $.ajax(wpdmpmAPI.chat_id,{
            method: 'GET',
            beforeSend: function (xhr) {
                xhr.setRequestHeader( 'X-WP-Nonce', wpdmpmAPI.nonce );
            }
        }).done(function (response) {
            localStorage.setItem("wpdmpm_chat_id", response.chat_id);
            __check = 1;
            $.get(chat_path+response.chat_id+'.json', function (response, status, xhr) {
                if(__dcount < response.data.length) {
                    __dcount = response.data.length;
                    __chat.messages = [greet];
                    __chat.messages = __chat.messages.concat(response.data);
                }
            });
        });
    });
</script>


