<?php
### Pinky ###
/**
 * Base: wpdmpro
 * Developer: shahjada
 * Team: W3 Eden
 * Date: 10/4/20 20:52
 */
if (!defined("ABSPATH")) die();
$current_user = wp_get_current_user();
?><!doctype html>
<html lang="en">
<head>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">
    <link rel="preconnect" href="https://fonts.googleapis.com">
    <link rel="preconnect" href="https://fonts.gstatic.com" crossorigin>
    <link href="https://fonts.googleapis.com/css2?family=Sen:wght@400;700&display=swap" rel="stylesheet">
    <?php PrivateMessage()->scripts(); ?>
    <style>

        /* css */
        *, ::after, ::before {
            -webkit-box-sizing: border-box;
            box-sizing: border-box
        }

        body, html {
            height: 100%;
            padding: 0;
            margin: 0;
        }

        body {
            font-family: Sen, sans-serif;
            font-size: 14px;
            font-weight: 400;
        }

        .ss-wrapper {
            overflow : hidden;
            height   : 100%;
            width    : 100%;
            position : relative;
            z-index  : 1;
            float: left;
        }

        .ss-content {
            height          : 100%;
            width           : 100%;
            padding         : 0 32px 0 0;
            position        : relative;
            right           : -18px;
            overflow        : auto;
            -moz-box-sizing : border-box;
            box-sizing      : border-box;
        }

        .ss-scroll {
            position            : relative;
            background          : #e08bfc;
            width               : 9px;
            border-radius       : 2px;
            top                 : 0;
            z-index             : 2;
            cursor              : pointer;
            opacity: 0;
            transition: opacity 0.25s linear;
        }

        .ss-container:hover .ss-scroll {
            opacity: 1;
        }

        .ss-grabbed {
            user-select: none;
            -o-user-select: none;
            -moz-user-select: none;
            -khtml-user-select: none;
            -webkit-user-select: none;
        }

        .chat-icon {
            max-width: 48px;
            position: fixed;
            display: inline-block;
            right: 16px;
            bottom: 16px;
            cursor: pointer
        }


        .avenue-messenger {
            display: none;
            height: 100% !important;
            max-height: 500px !important;
            min-height: 220px !important;
            width: 350px;
            background-color: #f9f2fd;
            position: fixed;
            right: 16px;
            bottom: 16px;
            margin: auto;
            z-index: 10;
            -webkit-box-shadow: 2px 10px 16px rgba(22, 20, 19, 0.2);
            box-shadow: 2px 10px 16px rgba(22, 20, 19, 0.2);
            overflow: visible;
            border-radius: 4px;
        }

        .available {
            position: relative;
            float: left;
            margin-right: 15px
        }

        .available::before {
            content: '';
            background-color: #3bd821;
            width: 7px;
            height: 7px;
            position: absolute;
            right: -3px;
            top: 10px;
            border-radius: 10px;
            border: 1px solid #fff
        }

        .circle {
            display: inline-block;
            width: 18px;
            background-size: cover;
            background-repeat: no-repeat;
            background-position: center center;
            border-radius: 50%;
            cursor: pointer
        }

        .menu .button {
            font-size: 14px;
            z-index: 12;
            color: #999;
            content: "...";
            width: 18px;
            height: 18px;
            position: absolute;
            cursor: pointer;
            text-align: center;
            line-height: 18px;
            right: 8px;
            border-radius: 10px;
            top: 8px
        }

        .chat {
            position: relative;
            width: 100%;
            height: 100%;
            max-height: 500px;
            z-index: 10;
            overflow: hidden;
            background: 0 0;
            display: -ms-flexbox;
            display: flex;
            display: -webkit-box;
            -webkit-box-pack: justify;
            -ms-flex-pack: justify;
            justify-content: space-between;
            -webkit-box-orient: vertical;
            -webkit-box-direction: normal;
            -ms-flex-direction: column;
            flex-direction: column
        }

        .message-box .message-submit {
            background-image: -webkit-gradient(linear, left top, left bottom, from(#e08bfc), to(#7357fb));
            background-image: -o-linear-gradient(top, #e08bfc, #7357fb);
            background-image: linear-gradient(180deg, #e08bfc, #7357fb)
        }

        .chat-wrap {
            position: relative;
            z-index: 2;
            width: 100%;
            padding: 7px 10px 5px
        }

        .chat-wrap .chat-title {
            font-size: 13px;
            color: #e08bfc;
            font-weight: 600;
            padding: 2px 0;
            text-align: center;
            text-transform: uppercase;
            text-indent: -20px;
            letter-spacing: .5px
        }

        .chat-wrap .chat-tag {
            color: #fff;
            font-size: 13px;
            font-weight: 500;
            opacity: .9;
            letter-spacing: .2px
        }

        .avenue-messenger .chat-para {
            color: #8792a4;
            font-size: 13px;
            font-weight: 500;
            max-width: 280px;
            margin: 0 auto;
            line-height: 20px
        }

        .messages {
            -webkit-box-flex: 1;
            -ms-flex: 1 1 auto;
            flex: 1 1 auto;
            overflow: hidden;
            position: relative;
            width: 100%
        }

        .messages .messages-content {
            position: absolute;
            top: 0;
            left: 0;
            padding-right: 24px;
            height: 100%;
            width: 100%
        }

        .messages .message.loading {
            min-height: 50px
        }

        .messages .message {
            clear: both;
            float: left;
            font-weight: 500;
            padding: 15px;
            background: #e08bfc;
            border-radius: 20px;
            font-size: 13px;
            position: relative;
            color: #fff;
            line-height: 20px;
            margin: 25px 50px 0;
            word-wrap: break-word;
        }

        .message::after, .message::before {
            content: "";
            position: absolute;
            z-index: 1;
            background: #e08bfc;
            border-radius: 20px
        }

        .message::before {
            bottom: 11px;
            left: -9px;
            height: 18px;
            width: 18px
        }

        .message::after {
            bottom: 27px;
            left: -20px;
            width: 10px;
            height: 10px
        }

        .message.message-personal::before {
            right: -9px;
            left: unset;
            background-attachment: fixed
        }

        .message.message-personal::after {
            right: -18px;
            left: unset
        }

        .messages .message.message-personal .timestamp {
            right: auto;
            left: -42px
        }

        .messages .message .timestamp {
            position: absolute;
            top: 18px;
            font-size: 12px;
            right: -42px;
            color: #939eb0;
            font-weight: 500;
            letter-spacing: .3px
        }

        .messages .message .avatar {
            position: absolute;
            z-index: 2;
            bottom: 38px;
            left: -48px;
            border-radius: 30px;
            width: 40px;
            height: 40px;
            overflow: hidden;
            margin: 0
        }

        .message.message-personal .avatar {
            left: auto;
            right: -48px
        }

        .messages .message .avatar img {
            width: 100%;
            height: auto
        }

        .messages .message.message-personal {
            color: #fff;
            float: right;
            font-weight: 500;
            background: #e08bfc
        }

        .messages .message:last-child {
            margin-bottom: 30px
        }

        .messages .message.loading span::after, .messages .message.loading span::before, .messages .message.loading::before {
            position: relative;
            content: "";
            display: block;
            width: 5px;
            height: 5px;
            border-radius: 50%;
            background: #fff;
            z-index: 2;
            opacity: .7;
            -webkit-animation: ball .45s cubic-bezier(0, 0, .15, 1) alternate infinite;
            animation: ball .45s cubic-bezier(0, 0, .15, 1) alternate infinite;
            border: none;
            bottom: -10px
        }

        .messages .message.loading::before {
            -webkit-animation-delay: .15s;
            animation-delay: .15s
        }

        .messages .message.loading span {
            display: block;
            font-size: 0;
            width: 22px;
            height: 10px;
            position: relative
        }

        .messages .message.loading span::before {
            left: 9px;
            top: 5px
        }

        .messages .message.loading span::after {
            -webkit-animation-delay: .75s;
            animation-delay: .75s;
            left: 18px;
            top: 0
        }

        @-webkit-keyframes ball {
            from {
                -webkit-transform: translateY(0) scaleY(.8);
                transform: translateY(0) scaleY(.8)
            }
            to {
                -webkit-transform: translateY(-10px);
                transform: translateY(-10px)
            }
        }

        @keyframes ball {
            from {
                -webkit-transform: translateY(0) scaleY(.8);
                transform: translateY(0) scaleY(.8)
            }
            to {
                -webkit-transform: translateY(-10px);
                transform: translateY(-10px)
            }
        }

        .message-box {
            position: relative;
            background-color: #fff;
            padding: 7px 18px;
            left: 0;
            right: 0;
            display: block
        }

        .message-box .message-input {
            border: none;
            resize: none;
            height: 45px;
            width: 100%;
            color: #444;
            padding: 14px 70px 14px 0;
            overflow: hidden;
            background-color: #fff;
            border-radius: 30px
        }

        .message-box .message-input:focus, .message-box .message-submit:focus {
            outline-offset: 0 !important;
            outline: 0 !important
        }

        .message-box .message-input, ::-moz-placeholder, ::-webkit-input-placeholder {
            color: #444;
            font-family: Sen, sans-serif;
            font-weight: 400;
            font-size: 13px;
            letter-spacing: .5px
        }

        .message-box .message-submit.attch:hover {
            opacity: 1
        }

        .message.message-personal span {
            white-space: pre-line;
        }

        .message-box .message-submit.attch {
            right: 54px;
            text-align: center;
            padding-top: 5px;
            border: 1px solid #e08bfc;
            background: 0 0;
            opacity: .65
        }

        .message-box .message-submit {
            position: absolute;
            z-index: 1;
            right: 18px;
            border: none;
            border-radius: 50px;
            cursor: pointer;
            width: 28px;
            height: 28px;
            top: 17px
        }

        .message-box .message-submit img {
            width: 12px;
            margin-top: 2px
        }

        @media only screen and (max-device-width: 667px), screen and (max-width: 450px) {
            .avenue-messenger {
                z-index: 2147483001 !important;
                width: calc(100% - 32px) !important;
                height: calc(100% - 32px) !important;
                max-height: none !important;
                top: 16px !important;
                left: 16px !important;
                right: 16px !important;
                bottom: 16px !important;
                border-radius: 4px !important;
            }

            .chat {
                border-radius: 4px !important;
                max-height: initial !important
            }
        }
        #wppmsg-login-form, #wppmsg-login-form .form {
            background: transparent !important;
            font-family: Sen, san-serif;
        }
        #wppmsg-login-form input{
            background: #ffffff;
            border: 1px solid #e8d6f2;
        }
        #wppmsg-login-form .form button{
            background: #D53F9A;
        }
        #wppmsg-login-form .form button:hover,#wppmsg-login-form .form button:active,#wppmsg-login-form .form button:focus {
            background: #c12b86;
        }
        .card{
            margin-top: 10px;
            background: #fff;
            padding: 10px;
            border: 1px solid #ddd;
            border-radius: 8px;
            max-width: 100%;
            overflow: hidden;
        }
        .card img{ max-width: 100%; }
    </style>
</head>
<body>
<div class="chat-icon">
     <img style="width: 48px" src="<?= PrivateMessage()->settings->general->chat_icon; ?>" alt="Chat" />
</div>
<div class="avenue-messenger">
    <div class="menu">
        <div class="button">&#10005;</div>
    </div>
    <div class="chat">
        <div class="chat-wrap">
            <div class="available"><img class="circle"
                                        src="<?php echo site_icon_url(512, 'https://wpdmcdn.s3.amazonaws.com/download-manager-logo.png') ?>"
                                        alt=""/></div>
            <div class="chat-title"><?php bloginfo('sitename'); ?></div>
        </div>
        <?php
        if(!PrivateMessage()->chat->allowedToChat()) {
            include __DIR__.'/chat-auth.php';
        } else { ?>
        <div class="messages" ss-container>
            <div class="messages-content" id="__chat_wpdmpm">
                <img src="https://wpdmcdn.s3.amazonaws.com/welcome1.svg" alt="Welcome" style="margin: 25px auto 15px;max-width: 270px;text-align: center;display: block;" />
                <div class="allmsgs" v-for="message in messages">
                    <div class="message message-personal new"  v-if="message.type === 'user'">
                        <figure class="avatar"><img  v-bind:src="message.sender_pic"></figure>
                        {{ message.sender_name }}:<br/>
                        <span class="msg-body" v-html="message.body"></span>
                        <div v-for="url in message.urls" :key="url">
                            <link-preview :url="url"></link-preview>
                        </div>
                        <!--div class="timestamp">15:53</div-->
                    </div>
                    <div class="message new" v-else>
                        <figure class="avatar"><img  v-bind:src="message.sender_pic"></figure>
                        {{ message.sender_name }}:<br/>
                        <span class="msg-body" v-html="message.body"></span>
                        <div v-for="url in message.urls" :key="url">
                            <link-preview :url="url"></link-preview>
                        </div>
                        <!-- div class="timestamp">15:8</div -->
                    </div>
                </div>
            </div>
        </div>
        <div class="message-box">
            <?php if(PrivateMessage()->settings->general->multiline_msg) { ?>
                <textarea  class="message-input"  placeholder="<?php echo is_user_logged_in() ? __('Write something...', 'wpdm-premium-packages') : __('Your email', 'wpdm-premium-packages');  ?>" type="text" id="__message" name="message"></textarea>
            <?php } else { ?>
                <input type="text" class="message-input"  placeholder="<?php echo is_user_logged_in() ? __('Write something...', 'wpdm-premium-packages') : __('Your email', 'wpdm-premium-packages');  ?>" type="text" id="__message" name="message" />
            <?php } ?><button type="button" id="wpdmpm-send-chat" class="message-submit">
                <svg style="padding: 5px 3px 3px;width: calc(100% - 4px);" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 492.004 492.004">
                    <path fill="#fff"
                          d="M484.14 226.886L306.46 49.202c-5.072-5.072-11.832-7.856-19.04-7.856-7.216 0-13.972 2.788-19.044 7.856l-16.132 16.136c-5.068 5.064-7.86 11.828-7.86 19.04s2.792 14.2 7.86 19.264L355.9 207.526H26.58C11.732 207.526 0 219.15 0 234.002v22.812c0 14.852 11.732 27.648 26.58 27.648h330.496L252.248 388.926c-5.068 5.072-7.86 11.652-7.86 18.864 0 7.204 2.792 13.88 7.86 18.948l16.132 16.084c5.072 5.072 11.828 7.836 19.044 7.836a26.74 26.74 0 0 0 19.04-7.872l177.68-177.68c5.084-5.088 7.88-11.88 7.86-19.1.016-7.244-2.776-14.04-7.864-19.12z"/>
                </svg>
            </button>
        </div>
        <?php } ?>
    </div>
</div>

<script src="<?php echo includes_url('js/jquery/jquery.js'); ?>"></script>
<script id="scroll">(function(n,t){function u(n){n.hasOwnProperty("data-simple-scrollbar")||Object.defineProperty(n,"data-simple-scrollbar",new SimpleScrollbar(n))}function e(n,i){function f(n){var t=n.pageY-u;u=n.pageY;r(function(){i.el.scrollTop+=t/i.scrollRatio})}function e(){n.classList.remove("ss-grabbed");t.body.classList.remove("ss-grabbed");t.removeEventListener("mousemove",f);t.removeEventListener("mouseup",e)}var u;n.addEventListener("mousedown",function(i){return u=i.pageY,n.classList.add("ss-grabbed"),t.body.classList.add("ss-grabbed"),t.addEventListener("mousemove",f),t.addEventListener("mouseup",e),!1})}function i(n){for(this.target=n,this.bar='<div class="ss-scroll">',this.wrapper=t.createElement("div"),this.wrapper.setAttribute("class","ss-wrapper"),this.el=t.createElement("div"),this.el.setAttribute("class","ss-content"),this.wrapper.appendChild(this.el);this.target.firstChild;)this.el.appendChild(this.target.firstChild);this.target.appendChild(this.wrapper);this.target.insertAdjacentHTML("beforeend",this.bar);this.bar=this.target.lastChild;e(this.bar,this);this.moveBar();this.el.addEventListener("scroll",this.moveBar.bind(this));this.el.addEventListener("mouseenter",this.moveBar.bind(this));this.target.classList.add("ss-container")}function f(){for(var i=t.querySelectorAll("*[ss-container]"),n=0;n<i.length;n++)u(i[n])}var r=n.requestAnimationFrame||n.setImmediate||function(n){return setTimeout(n,0)};i.prototype={moveBar:function(){var t=this.el.scrollHeight,i=this.el.clientHeight,n=this;this.scrollRatio=i/t;r(function(){n.bar.style.cssText="height:"+i/t*100+"%; top:"+n.el.scrollTop/t*100+"%;right:-"+(n.target.clientWidth-n.bar.clientWidth)+"px;"})}};t.addEventListener("DOMContentLoaded",f);i.initEl=u;i.initAll=f;n.SimpleScrollbar=i})(window,document)</script>
<script src="https://cdn.jsdelivr.net/npm/vue"></script>
<script>

    var chat_path = '<?php echo \PrivateMessage\Chat\ChatController::getChatDir(true) ?>';

    Vue.component('link-preview', {
        data() {
            return {
                preview: null,
                elementVisible:true
            }
        },
        props: ['url'],
        mounted() {
            var vm = this;
            jQuery.ajax(wpdmpmAPI.get_link_meta, {
                method: 'GET',
                data: {url: vm.url},
                beforeSend: function (xhr) {
                    xhr.setRequestHeader('X-WP-Nonce', wpdmpmAPI.nonce);
                }
            }).done(function (data) {
                vm.preview = data;
            });
            setTimeout(() => vm.elementVisible = false, 3000)

        },
        methods: {
            removePreview: function (event) {
                jQuery(event.target).closest('.card').remove();
            }
        },
        template: `<div v-if="preview" class="card mt-1" :key="preview.title"
                         style="width: auto; position: relative;">
                        <i v-on:click="removePreview" style="position: absolute;right: 5px;top:5px;" class="fas fa-window-close"></i>
                        <img style="height: 100px;object-fit: cover;" class="card-img-top"
                             v-bind:src="preview.img_src" alt="Card image cap">
                        <div class="card-body">
                            <a target="_blank" v-bind:href="preview.url" class="card-title" v-html="preview.title"></a>
                        </div>
                    </div>
                    <div v-else v-show="elementVisible" class="card justify-content-center mt-1" style="width: 18rem; height: 9rem; position: relative;">
                        <i v-on:click="removePreview" style="position: absolute;right: 5px;top:5px;" class="fas fa-window-close"></i>
                        <i style="width: 1em;" class="fa-2x fas fa-spinner fa-pulse m-auto"></i>
                    </div>`
    })

    var greet = {
        sender_pic      : wpdmpmAPI.admin_avatar,
        sender_name     : 'Admin',
        body            : '<?php echo is_user_logged_in() ? 'Hello '.$current_user->display_name.", welcome back. How may I help you today?" : 'Please give me your email address in case we disconnect in the middle somehow'; ?>'
    };
    var __chat = new Vue({
        el: '#__chat_wpdmpm',
        data: {
            messages: [
                greet
            ]
        }
    });
</script>
<script src="<?php echo PM_ASSET_URL.'js/wppmsg.js' ?>"></script>
</body>
</html>

