<?php


namespace PrivateMessage\Dialogflow;

require 'vendor/autoload.php';

use Exception;
use Google\Cloud\Dialogflow\V2\SessionsClient;
use Google\Cloud\Dialogflow\V2\TextInput;
use Google\Cloud\Dialogflow\V2\QueryInput;


/*class Dialogflow
{
    public $sessionID;
    public $projectId;

    function __construct()
    {
        $this->sessionID = uniqid();
        $this->projectId = PrivateMessage()->settings->chatautomation->project_id;
    }

    function getReply($text)
    {
        $languageCode = 'en-US';

        // new session
        $sessionsClient = new SessionsClient();
        $session = $sessionsClient->sessionName($this->projectId, $this->sessionID);

        // create text input
        $textInput = new TextInput();
        $textInput->setText($text);
        $textInput->setLanguageCode($languageCode);

        // create query input
        $queryInput = new QueryInput();
        $queryInput->setText($textInput);

        // get response and relevant info
        $response = $sessionsClient->detectIntent($session, $queryInput);
        $queryResult = $response->getQueryResult();
        $queryText = $queryResult->getQueryText();
        $intent = $queryResult->getIntent();
        $displayName = $intent->getDisplayName();
        $confidence = $queryResult->getIntentDetectionConfidence();
        $fulfilmentText = $queryResult->getFulfillmentText();

        $sessionsClient->close();

        return $fulfilmentText;

    }

}*/



class Dialogflow
{
    private $sessionsClient;

    private $session;

    public $sessionID;

    public $projectId;

    private $keyfile;

    function __construct()
    {
        $this->sessionID = uniqid();
        $this->projectId = PrivateMessage()->settings->chatautomation->project_id;
        $this->keyfile = __DIR__ . '/w3eden-ec30679d8313.json';
    }

    public function initSession()
    {
        if ($this->sessionsClient) return;
        $keydata = json_decode(file_get_contents($this->keyfile), true);

        if (!empty($keydata)) {
            $options = [
                'credentials' => $keydata
            ];
            $this->sessionsClient = new SessionsClient($options);
            $this->session = $this->sessionsClient->sessionName($keydata['project_id'], $this->sessionID);
        }
    }


    public function getReply($text)
    {
        $this->initSession();

        $textInput = new TextInput();
        $textInput->setText($text);
        $textInput->setLanguageCode('en-US');
        $queryInput = new QueryInput();
        $queryInput->setText($textInput);
        try {
            //request
            $response = $this->sessionsClient->detectIntent($this->session, $queryInput);
            //response
            $intentResponse = $response->getQueryResult();
            $intent = $intentResponse->getIntent();
            $fulfilmentText = $intentResponse->getFulfillmentText();
            return $fulfilmentText;
        } catch (Exception $e) {
            return $e->getMessage();
        }
    }
}