<?php


namespace PrivateMessage\Message;

if (!defined("ABSPATH")) die("Shit happens!");

use PrivateMessage\__\__;
use PrivateMessage\__\__Crypt;
use PrivateMessage\__\__FileSystem;
use PrivateMessage\__\__Email;
use PrivateMessage\__\__MailUI;
use PrivateMessage\__\__Messages;
use PrivateMessage\__\__Template;
use PrivateMessage\PrivateMessage;

class MessageController
{

    private static $instance;

    public static function getInstance()
    {
        if (self::$instance === null) {
            self::$instance = new self;
        }
        return self::$instance;
    }

    private function __construct()
    {
        new RestAPI();

        add_action("init", array($this, "attachmentDownload"));

        add_action("admin_menu", [$this, "adminMenu"]);
        add_action('wp_ajax_wpdm_onesignal_player_id', array($this, 'saveOneSignalPlayerID'));
        add_action('wp_ajax___wpdmpm_attach_file', array($this, 'uploadFile'));
        add_action('wp_ajax_wpdmpm_delete__attachment', array($this, 'deleteAttachment'));
        add_filter('wpdm_user_dashboard_menu', array($this, 'dashboardMenu'), 10, 1);
        add_filter("wpdm_user_profile_menu", array($this, 'profileMenu'));
        add_action("wp_insert_comment", array($this, "setupReply"), 10, 2);

        add_shortcode("private_message", array($this, "privateMessage"));
        add_shortcode("pm_to_author", array($this, "sentToAuthor"));
        add_shortcode("pm_to_author_embed", array($this, "sentToAuthorEmbed"));
        add_shortcode("pm_to_user", array($this, "sentToUser"));
        add_shortcode("pm_to_user_embed", array($this, "sentToUserEmbed"));
        add_shortcode("unread_msg_count", array($this, "unreadMessageCount"));

        add_action("wp_footer", [$this, 'pmModalForm']);

    }

    function adminMenu()
    {
        add_menu_page(__('Messages', PM_TEXT_DOMAIN), __('Messages', PM_TEXT_DOMAIN), PM_ADMIN_CAP, 'wpdmpm', [$this, 'pmAdmin']);
        add_submenu_page("wpdmpm", __('Private Messages', PM_TEXT_DOMAIN), __('Private Messages', PM_TEXT_DOMAIN), PM_ADMIN_CAP, 'wpdmpm', [$this, 'pmAdmin']);
    }


    function profileMenu($menu_items)
    {
        $menu_items['message'] = array('icon' => 'fas fa-comments', 'name' => __("Message", "download-manager"), 'static_content' => array($this, 'messageModal'));
        return $menu_items;
    }

    function pmAdmin()
    {
        include __DIR__ . '/views/pm-admin.php';
    }

    function privateMessage($params = array())
    {
        if (!is_user_logged_in())
            return PrivateMessage()->user->login->form($params);

        ob_start();
        include __Template::locate("pm-front.php", __DIR__ . '/views');
        $data = ob_get_clean();
        return $data;
    }


    function saveOneSignalPlayerID()
    {
        $player_ids = get_user_meta(get_current_user_id(), '__wpdm_onesignal_player_id');
        $player_ids = maybe_unserialize($player_ids);
        $player_id = __::query_var('__wpdm_onesignal_player_id', 'txt');
        if (!in_array($player_id, $player_ids)) {
            $player_ids[] = $player_id;
            update_user_meta(get_current_user_id(), '__wpdm_onesignal_player_id', $player_ids);
        }
        wp_send_json(array('success' => true, 'message' => 'Saved'));
    }

    function setupReply($id, $comment)
    {
        global $current_user;

        if (get_post_type($comment->comment_post_ID) !== 'message') return;
        if (!is_admin()) return;

        $sender = $current_user;
        $msg = get_post($comment->comment_post_ID);
        $msg_receiver = get_post_meta($msg->ID, '__receiver', true);

        update_comment_meta($id, '__deleted_by_receiver', 0);
        update_comment_meta($id, '__deleted_by_sender', 0);

        update_post_meta($comment->comment_post_ID, '__wpdmpm_sentbox_' . $sender->ID, 1);
        update_post_meta($comment->comment_post_ID, '__wpdmpm_inbox_' . $msg->post_author, 1);

        update_post_meta($comment->comment_post_ID, '__wpdmpm_last_reply_' . $sender->ID, $id);

        $last_reply_receiver = $current_user->ID == $msg->post_author ? $msg_receiver : $current_user->ID;
        update_post_meta($comment->comment_post_ID, '__wpdmpm_last_message_' . $last_reply_receiver, $id);

        update_post_meta($comment->comment_post_ID, '__wpdmpm_last_reply_receiver', $last_reply_receiver);


        $new_status = $sender->ID == $msg->post_author ? $msg_receiver : $msg->post_author;
        //if($msg_receiver === $sender->ID) {
        update_post_meta($comment->comment_post_ID, '__msg_status_' . $new_status, 'new');
        $_post = array(
            'ID' => $comment->comment_post_ID,
            'post_excerpt' => time(),
        );
        wp_update_post($_post);
        //}

        $mail_receiver = get_userdata($new_status);
        $admins = get_users(array('role__in' => ('administrator')));
        $user = $admins[0];
        $admin_email = PrivateMessage()->settings->general->pm_admin_email != '' ? PrivateMessage()->settings->general->pm_admin_email : $user->user_email;
        $to_email = (user_can($mail_receiver, 'manage_options')) ? $admin_email : $mail_receiver->user_email;
        $url = isset($this->pm_base_url) && $this->pm_base_url != '' ? $this->pm_base_url : (function_exists('wpdm_user_dashboard_url') ? wpdm_user_dashboard_url(array('udb_page' => 'messages')) : '');
        $params = array(
            'from' => $sender->user_email,
            'from_name' => $sender->display_name,
            'to_email' => $to_email,
            'subject' => "[RE# {$id}] {$msg->post_title}",
            'message' => __MailUI::panel("REPLY# {$id}", array($comment->comment_content . "<hr style='height: 1px;border: 0;border-top: 1px solid #dddddd;'/><a style='display: block;margin: 0 !important;' class='button green' href='{$url}'>View Reply</a>"))
        );
        __Email::send("default", $params);
    }

    function uploadFile()
    {

        if (!file_exists(PM_ATTACHMENT_DIR)) {
            __FileSystem::mkDir(PM_ATTACHMENT_DIR, 0755, true);
            __FileSystem::blockHTTPAccess(PM_ATTACHMENT_DIR);
        }

        $id = uniqid();
        $filename = $_FILES['wpdmpm_file']['name'] . ".wpdmpm." . $id;
        $user_files = maybe_unserialize(get_user_meta(get_current_user_id(), '__wpdmpm_attachments', true));
        if (!is_array($user_files)) $user_files = array();
        $user_files[] = $filename;
        update_user_meta(get_current_user_id(), '__wpdmpm_attachments', $user_files);
        move_uploaded_file($_FILES['wpdmpm_file']['tmp_name'], PM_ATTACHMENT_DIR . $filename);
        wp_send_json(array('name' => $_FILES['wpdmpm_file']['name'], 'ofile' => $filename, 'id' => "__{$id}"));
    }

    function deleteAttachment()
    {
        $user_files = maybe_unserialize(get_user_meta(get_current_user_id(), '__wpdmpm_attachments', true));
        if (($index = array_search(__::query_var('file'), $user_files)) !== false) {
            @unlink(PM_ATTACHMENT_DIR . __::query_var('file'));
            unset($user_files[$index]);
            update_user_meta(get_current_user_id(), '__wpdmpm_attachments', $user_files);
            wp_send_json(array('success' => true));
        }
        wp_send_json(array('success' => false, 'files' => $user_files));
    }

    function attachmentDownload()
    {
        if (strstr($_SERVER['REQUEST_URI'], 'wpdmpm-attachment')) {
            list(, $attachment) = explode("wpdmpm-attachment/", $_SERVER['REQUEST_URI']);
            $attachment = __Crypt::decrypt($attachment, true);
            if (!is_user_logged_in() || get_current_user_id() !== $attachment['uid']) {
                __Messages::error(__('You are not authorized to download this file', PM_TEXT_DOMAIN), 1);
            }
            list($filename,) = explode(".wpdmpm", $attachment['file']);
            __FileSystem::downloadFile(PM_ATTACHMENT_DIR . $attachment['file'], $filename);
            die();
        }
    }

    function messageModal()
    {
        $user = get_user_by('login', get_query_var('profile'));
        if(!$user) return '';
        include __Template::locate("send-message.php", __DIR__ . '/views');
    }

    function sentToAuthor($params = [])
    {
        global $post;
        ob_start();
        $author = $post->post_author;
        include __Template::locate("send-to-author.php", __DIR__.'/views');
        return ob_get_clean();
    }
    function sentToAuthorEmbed($params = [])
    {
        global $post;
        ob_start();
        $author = $post->post_author;
        include __Template::locate("send-to-author-embed.php", __DIR__ . '/views');
        return ob_get_clean();
    }

    function sentToUser($params = [])
    {
        global $post;
        ob_start();
        if (!isset($params['id']) || (int)$params['id'] <= 0 || !get_userdata($params['id'])) return 'Invalid user ID';
        $author = (int)$params['id'];
        include __Template::locate("send-to-author.php", __DIR__ . '/views');
        return ob_get_clean();
    }

    function sentToUserEmbed($params = [])
    {
        global $post;
        ob_start();
        if (!isset($params['id']) || (int)$params['id'] <= 0 || !get_userdata($params['id'])) return 'Invalid user ID';
        $author = (int)$params['id'];
        include __Template::locate("send-to-author-embed.php", __DIR__ . '/views');
        return ob_get_clean();
    }

    function pmModalForm()
    {
        global $post;
        if (!is_object($post)) return;
        $showHere = false;
        $showHere = apply_filters("PrivateMessage/Message/pmModalForm", $showHere);
        if (has_shortcode($post->post_content, "pm_to_author") || has_shortcode($post->post_content, "pm_to_user") || has_shortcode($post->post_content, "wppmsg_members") || $showHere) {
            include __Template::locate("pm-modal-form.php", __DIR__ . '/views');
        }
    }

    function dashboardMenu($menu_items)
    {
        if (PrivateMessage()->settings->general->pm_wpdm_dashboard) {
            if (count($menu_items) > 4) {
                $new_item['messages'] = array('name' => __('Messages', PM_TEXT_DOMAIN), 'shortcode' => '[private_message menu="top"]');
                $menu_items = array_merge(array_splice($menu_items, 0, 2), $new_item, $menu_items);

            } else
                $menu_items['messages'] = array('name' => __('Messages', PM_TEXT_DOMAIN), 'shortcode' => '[private_message menu="top"]');
        }

        return $menu_items;
    }

    function userLimit()
    {
        global $current_user;
        $__pmlimit = get_option('__pmlimit', []);
        $user_limit = 0;
        foreach ($current_user->roles as $role) {
            if ((int)__::valueof($__pmlimit, $role) === 0) return 0;
            $user_limit += (int)__::valueof($__pmlimit, $role);
        }
        return $user_limit;
    }

    /**
     * Get unread message count
     * @param null $uid
     * @return int
     */
    function countUnread($uid = null)
    {
        global $wpdb;
        if (is_user_logged_in() && !$uid) $uid = get_current_user_id();
        if (!$uid) return 0;
        $key = "__msg_status_{$uid}";
        $unread = (int)$wpdb->get_var("select count(*) from {$wpdb->prefix}postmeta where meta_key='{$key}' and meta_value='new'");
        return $unread;
    }

    /**
     * Shortcode callback function to get unread message count
     * @param $params
     * @return int
     */
    function unreadMessageCount($params)
    {
        return $this->countUnread(__::valueof($params, 'uid'));
    }

}
