<?php
/**
 * User: shahnuralam
 * Date: 12/12/18
 * Time: 1:12 AM
 */
if (!defined('ABSPATH')) die();
?>

<div id="msg-cont">
    <div class="row">
        <div class="col-md-9">
            <div class="card card-message">
                <div class="card-body">
                    <h3 class="sechead fetfont pb-3"><i
                                class="fas fa-envelope-open-text"></i> <?php _e('Message', PM_TEXT_DOMAIN); ?></h3>
                    <h3 class="sechead fetfont pb-3" style="font-size: 10pt;font-weight: 600">
                        {{ message.post_title }}
                    </h3>
                    <?php
                    do_action("PrivateMessage/Message/Views/ViewMessage/BeforeMessage");
                    ?>
                    <span style="white-space: break-spaces;" v-html="message.post_content"></span>
                    <br>
                    <br>
                    <div v-if="message.product">
                        <h6>Product:</h6>
                        <div class="media border mt-3" style="border: 1px solid rgba(0,0,0,.07);border-radius: .25rem;">
                            <img class="mr-3 w-25 mb-0" v-bind:src="message.product.image[0]" style="width: 15%">
                            <div class="media-body pt-3">
                                <a target="_blank" v-bind:href="message.product.link"><h5 class="mt-0">
                                        {{message.product.title}}</h5></a>
                                {{message.product.description}}
                            </div>
                        </div>
                    </div>
                    <br>
                    <div v-for="url in message.urls" :key="message.ID">
                        <link-preview :url="url"></link-preview>
                    </div>
                </div>
                <?php
                do_action("PrivateMessage/Message/Views/ViewMessage/AfterMessage");
                ?>
                <div class="card-footer" style="background: #fbfbfb !important">
                    <div class="media attachment-single" v-for="attachment in message.attachments">
                        <div class="media-body">
                            <a v-bind:href="attachment.download_url" target="_blank"><i
                                        class="fas fa-file-alt mr-2"></i>{{ attachment.file }}</a>
                        </div>
                    </div>
                </div>
                <div class="card-footer text-muted">
                    <i class="far fa-user-circle"></i> {{ message.author_name }} &nbsp;
                    <i class="far fa-calendar-check"></i> {{ message.post_date }} &nbsp;
                </div>
            </div>
            <div class="card card-reply" v-for="comment in message.comments">
                <div class="card-body">
                    <span v-html="comment.comment_content"></span>
                    <br>
                    <div v-for="url in comment.urls" :key="comment.ID">
                        <link-preview :url="url"></link-preview>
                    </div>
                </div>
                <div class="card-footer" style="background: #fbfbfb !important">
                    <div class="media attachment-single" v-for="attachment in comment.attachments">
                        <div class="media-body">
                            <a v-bind:href="attachment.download_url" target="_blank"><i
                                        class="fas fa-file-alt mr-2"></i>{{ attachment.file }}</a>
                        </div>
                    </div>
                </div>
                <div class="card-footer text-muted">
                    <div class="pull-right float-right">RE#{{ comment.comment_ID }}</div>
                    <i class="far fa-user-circle"></i> {{ comment.author_name }} &nbsp;
                    <i class="far fa-calendar-check"></i> {{ comment.comment_date }} &nbsp;
                </div>
            </div>

            <form method="post" id="post_reply">
                <div class="card">
                    <input id="message_id" type="hidden" name="message_id" v-bind:value="message.ID">
                    <textarea id="reply" name="reply" required="required"
                              placeholder="<?= esc_attr__('Write your reply...', PM_TEXT_DOMAIN) ?>"
                              class="form-control"
                              style="max-width: 100%;min-width: 100%;border: 0;min-height: 80px"></textarea>
                    <div class="card-footer" id="file__attachments-reply" style="display: none">
                        <div id="wpdm-upload-ui-reply" class="text-center image-selector-panel">
                            <div id="wpdm-drag-drop-area-reply">

                                <div class="panel-footer-x">
                                    <input type="hidden" name="__attachment" id="__attachment" value=""/>

                                    <div class="progress" id="wmprogressbar-reply"
                                         style="height: 30px !important;border-radius: 3px !important;margin: 0;position: relative;background: #0d406799;display: none;box-shadow: none">
                                        <div id="wmprogress-reply"
                                             class="progress-bar progress-bar-striped progress-bar-animated"
                                             role="progressbar" aria-valuenow="0" aria-valuemin="0" aria-valuemax="100"
                                             style="width: 0%;line-height: 30px;background-color: #007bff"></div>
                                        <div class="fetfont"
                                             style="font-size:9px;position: absolute;line-height: 30px;height: 30px;width: 100%;z-index: 999;text-align: center;color: #ffffff;font-weight: 800;letter-spacing: 1px"><?= esc_attr__('UPLOADING', PM_TEXT_DOMAIN) ?>
                                            ... <span id="wmloaded-reply">0</span>%
                                        </div>
                                    </div>

                                    <div class="clear"></div>

                                </div>
                            </div>
                        </div>
                        <div id="__attached_files_reply">
                            <div class="media attachment-single" v-bind:id="file.id" v-for="file in newra">
                                <div class="media-body"><input type="hidden" name="__attached_files[]"
                                                               v-bind:value="file.ofile"/>
                                    <i class="fas fa-file-alt mr-2"></i>{{ file.name }}
                                </div>
                                <div class="ml-3">
                                    <button type="button" v-bind:data-file="file.ofile" v-bind:data-id="file.id"
                                            class="btn btn-link btn-sm text-danger delete__attachment"><i
                                                class="fa fa-trash"></i></button>
                                </div>
                            </div>
                        </div>
                    </div>
                    <div class="card-footer text-right">
                        <button type="submit"
                                class="btn btn-primary"><?= esc_attr__('Reply', PM_TEXT_DOMAIN) ?></button>
                        <div class="float-left">
                            <button id="wpdm-browse-button-reply" style="text-transform: unset" type="button"
                                    class="btn btn-link"><i
                                        class="fa fa-paperclip"></i> <?php echo __("Attach File", PM_TEXT_DOMAIN); ?>
                            </button>
                        </div>
                    </div>
                </div>
            </form>

        </div>
        <div class="col-md-3">
            <div class="card profile-card">
                <div class="list-group list-group-flush">
                    <div class="list-group-item">
                        <div class="text-center">
                            <span v-html="message.profile.avatar"></span>
                            <a v-bind:href="message.profile.url"><h3>{{ message.profile.display_name }}</h3></a>
                            <small>{{ message.profile.title }}</small>
                        </div>
                    </div>
                    <?php
                    do_action("PrivateMessage/Message/Views/OpenMessage/BeforeSenderAbout");
                    ?>
                    <div class="list-group-item">
                        <strong><?php _e('About:', PM_TEXT_DOMAIN); ?></strong>
                        <p class="mb-0" v-html="message.profile.description"></p>
                    </div>
                    <?php if(current_user_can('manage_options')) { ?>
                    <div class="list-group-item">
                        <strong><?php _e('Email:', PM_TEXT_DOMAIN); ?></strong>
                        <p class="mb-0">{{ message.profile.user_email }}</p>
                    </div>
                    <div class="list-group-item">
                        <strong><?php _e('Member Since:', PM_TEXT_DOMAIN); ?></strong>
                        <p class="mb-0">{{ message.profile.signup_date }}</p>
                    </div>
                    <?php
                    }
                    do_action("PrivateMessage/Message/Views/OpenMessage/AfterMemberSince");
                    ?>
                </div>
            </div>
        </div>
    </div>
</div>


