<?php
$current_user = wp_get_current_user();
$pms = maybe_unserialize(get_option('pm_settings'));

$mlimit = !@empty($pms['max_msg'][array_values($current_user->roles)[0]]) ? $pms['max_msg'][array_values($current_user->roles)[0]] : 0;

/*Count messages sent by current user*/
$authorid = get_current_user_id();
$user_msg_count = 0;
$user_msg_count = count_user_posts($authorid, 'message');

$percent = $mlimit > 0 ? $user_msg_count * 100 / $mlimit : 0;

?>
<div class="w3eden">
    <div class="main-content pm-content" style="padding: 30px 30px 30px 10px">
        <div class="card" style="padding: 0;margin-bottom: 20px">
            <div class="card-body">
                <h2 style="margin: 0;padding: 0;font-size: 14pt;font-weight: 700"><?php _e('Private Messages', PM_TEXT_DOMAIN); ?></h2>
            </div>
            <div class="card-footer">
                <?php _e('Check your messages and moderate all messages from site users', PM_TEXT_DOMAIN); ?>
            </div>
        </div>
        <!-- Widget Stats -->
        <div class="row">

            <div class="col-md-3">

                <a class="btn btn-info btn-lg btn-block" style="margin-bottom: 15px" href="#compose" data-toggle="tab"
                   aria-expanded="true"><i class="fas fa-pen-square mr-2"></i> <?php _e('Compose', PM_TEXT_DOMAIN); ?>
                </a>

                <div class="list-group">
                    <a class="list-group-item active" href="#inbox" data-toggle="tab" aria-expanded="false">
                        <div class="media">
                            <div class="mr-3">
                                <i class="fas fa-envelope-open-text color-purple" style="font-size: 24pt"></i>
                            </div>
                            <div class="media-body">
                                <strong><?php _e('Inbox', PM_TEXT_DOMAIN); ?></strong><br/>
                                <small><span id="inbox-count">...</span> <?php _e('new messages', PM_TEXT_DOMAIN); ?>
                                </small>
                            </div>
                        </div>
                    </a>
                    <a class="list-group-item" href="#sent" data-toggle="tab">
                        <div class="media">
                            <div class="mr-3">
                                <i class="fas fa-paper-plane color-blue" style="font-size: 24pt"></i>
                            </div>
                            <div class="media-body">
                                <strong>Sent</strong><br/>
                                <small><span id="sent-count">...</span> <?php _e('sent messages', PM_TEXT_DOMAIN); ?>
                                </small>
                            </div>
                        </div>
                        <a class="list-group-item" href="#allmessage" data-toggle="tab">
                            <div class="media">
                                <div class="mr-3">
                                    <i class="fas fa-layer-group color-red" style="font-size: 24pt"></i>
                                </div>
                                <div class="media-body">
                                    <strong>All Messages</strong><br/>
                                    <small><span
                                                id="all-count">...</span> <?php _e('total messages', PM_TEXT_DOMAIN); ?>
                                    </small>
                                </div>
                            </div>
                        </a>
                </div>


            </div>


            <div class="col-md-9">

                <div class="tab-content">
                    <div class="tab-pane fade in active show" id="inbox">

                        <!-- Inbox Tab -->

                        <?php
                        include('received-message.php');
                        ?>

                        <!--/ Inbox Tab -->

                    </div>
                    <div class="tab-pane fade" id="compose">

                        <!-- Compose Tab -->

                        <?php
                        include('message-form-admin.php');
                        ?>

                        <!--/ Compose Tab -->
                    </div>
                    <div class="tab-pane fade" id="sent">

                        <?php
                        include('sent-message.php');
                        ?>

                    </div>

                    <div class="tab-pane fade" id="viewmessage">

                        <?php
                        include('open-message.php');
                        ?>

                    </div>

                    <div class="tab-pane fade" id="allmessage">

                        <?php
                        include('all-messages.php');
                        ?>

                    </div>

                </div>

            </div>


        </div>
    </div>
</div>
<style>
    .w3eden .profile-card img.avatar {
        max-width: calc(100% - 60px);
        margin: 30px;
        border-radius: 500px;
        height: auto;
    }

    @media (max-width: 1440px) {
        .w3eden .profile-card img.avatar {
            max-width: calc(100% - 20px);
            margin: 10px;
        }
    }

    .w3eden .card h3 {
        font-size: 13pt;
        margin: 5px 0;
    }

    .w3eden .card {
        padding: 0;
        margin: 0;
    }

    .sechead {
        margin: 0 0 15px 0 !important;
        font-size: 14pt;
        line-height: normal;
        font-weight: bold;
        border-bottom: 1px solid #eeeeee;
        padding-bottom: 10px;

    }

    .title-icon {
        margin-top: 2px;
        margin-right: 5px;
    }

    .table td {
        border-color: #eeeeee !important;
    }

    .table {
        margin: 0 !important;
    }

    .list-group a .fas {
        margin-right: 5px !important;
    }

    #mlimit {
        position: relative;
    }

    .pull-right #mlimit {
        margin: 0;
        width: 200px;
        height: 37px;
        border-radius: 3px !important;
    }

    #mlimit .progress-bar {
        background-color: #8f6fd5;
    }

    label.input-group-addon {
        cursor: pointer;
    }

    .card-body p {
        margin-bottom: 10px;
    }

    .card-body p:last-child {
        margin-bottom: 0;
    }

    .w3eden a.wpdmpm-open,
    .w3eden a.wpdmpm-status-read {
        color: #90979c;
    }

    .w3eden a.wpdmpm-status-new {
        color: #4280de;
    }

    .w3eden .tab-content {
        padding: 0;
        border: 0;
    }

    .tab-content .fade.in {
        background: transparent !important;
    }

    .media.attachment-single {
        font-size: 9pt;
        font-weight: 400;
        margin: 0;
        line-height: 1.6;
    }

    .main-content.pm-content a.list-group-item:not(.active) .media-body {
        color: #4b6a8d !important;
    }

    .main-content.pm-content a.list-group-item:focus,
    .main-content.pm-content a.list-group-item:hover {
        text-decoration: none;
        box-shadow: none;
    }

    .w3eden .list-group-item.active {
        color: #fff;
        background-color: #8e9bb1;
        border-color: #8e9bb1;
    }

    #msg-cont .card {
        margin-bottom: 15px;
    }

    .card-footer:empty {
        display: none;
    }

</style>
<?php
/* Restore original Post Data */
wp_reset_postdata();
?>
<script src="https://cdn.jsdelivr.net/npm/vue"></script>

<script>

    var $ = jQuery, $wppmsg_reply_attachment = 0;

    Vue.component('link-preview', {
        data() {
            return {
                preview: null,
                elementVisible:true
            }
        },
        props: ['url'],
        mounted() {
            var vm = this;
            jQuery.ajax(wpdmpmAPI.get_link_meta, {
                method: 'GET',
                data: {url: vm.url},
                beforeSend: function (xhr) {
                    xhr.setRequestHeader('X-WP-Nonce', wpdmpmAPI.nonce);
                }
            }).done(function (data) {
                vm.preview = null;
                vm.preview = data;
            });
            setTimeout(() => vm.elementVisible = false, 3000)

        },
        methods: {
            removePreview: function (event) {
                jQuery(event.target).closest('.card').remove();
            }
        },
        template: `<div v-if="preview" class="card mt-1" :key="preview.title"
                         style="width: 18rem; position: relative;">
                        <i v-on:click="removePreview" style="position: absolute;right: 5px;top:5px;" class="fas fa-window-close"></i>
                        <img style="height: 100px;object-fit: cover;" class="card-img-top"
                             v-bind:src="preview.img_src" alt="Card image cap">
                        <div class="card-body">
                            <a target="_blank" v-bind:href="preview.url" class="card-title" v-html="preview.title"></a>
                        </div>
                    </div>
                    <div v-else v-show="elementVisible" class="card justify-content-center mt-1" style="width: 18rem; height: 9rem; position: relative;">
                        <i v-on:click="removePreview" style="position: absolute;right: 5px;top:5px;" class="fas fa-window-close"></i>
                        <i style="width: 1em;" class="fa-2x fas fa-spinner fa-pulse m-auto"></i>
                    </div>`
    })

    var allmsg = new Vue({
        el: '#allmsg-table',
        data: {
            messages: []
        }
    });

    var inbox = new Vue({
        el: '#inbox-table',
        data: {
            messages: []
        }
    });

    var sent = new Vue({
        el: '#sent-table',
        data: {
            messages: []
        }
    });

    var message = new Vue({
        el: '#msg-cont',
        data: {
            message: {
                profile: []
            },
            newra: []
        },
    });

    var __attached_files = new Vue({
        el: '#__attached_files',
        data: {
            files: []
        }
    });

    var searchusers = new Vue({
        el: '#wpdmpm-sugestions',
        data: {
            suggestions: [{name: 'Start Typing', email: 'to see the sugestions...'}]
        }
    });

    WPPMSG.audio = "<?php echo PM_ASSET_URL . "sounds/filling-your-inbox.mp3"; ?>";

    class WPDMPM {

        static refreshInbox() {
            jQuery.ajax(wpdmpmAPI.get_messages, {
                method: 'GET',
                beforeSend: function (xhr) {
                    xhr.setRequestHeader('X-WP-Nonce', wpdmpmAPI.nonce);
                }
            }).done(function (data) {
                inbox.messages = data;
                jQuery('#inbox-count').html(data.length);
            });
        }

        static refreshAllMsg() {
            jQuery.ajax(wpdmpmAPI.get_messages, {
                method: 'GET',
                data: {folder: "all"},
                beforeSend: function (xhr) {
                    xhr.setRequestHeader('X-WP-Nonce', wpdmpmAPI.nonce);
                }
            }).done(function (data) {
                allmsg.messages = data;
                jQuery('#all-count').html(data.length);
            });
        }

        static refreshSent() {
            jQuery.ajax(wpdmpmAPI.get_messages, {
                method: 'GET',
                data: {folder: "sent"},
                beforeSend: function (xhr) {
                    xhr.setRequestHeader('X-WP-Nonce', wpdmpmAPI.nonce);
                }
            }).done(function (data) {
                sent.messages = data;
                jQuery('#sent-count').html(data.length);
            });
        }

        static checkNewMessage() {

            jQuery.ajax(wpdmpmAPI.check_new_message, {
                method: 'GET',
                beforeSend: function (xhr) {
                    xhr.setRequestHeader('X-WP-Nonce', wpdmpmAPI.nonce);
                }
            }).done(function (data) {
                if (data.new_message) {
                    //WPPMSG.notify("<b>"+data.new_message+"</b> new message(s) in your inbox!")
                    WPPMSG.pushNotify("New Message", "You have " + data.new_message + " new message!", "https://cdn2.iconfinder.com/data/icons/black-friday-shopping-3/228/Asset_1120-512.png", "https://cdn1.iconfinder.com/data/icons/hawcons/32/699318-icon-47-note-important-128.png", location.href);
                    WPPMSG.beep();
                    WPDMPM.refreshInbox();
                }
            });

            setTimeout("WPDMPM.checkNewMessage()", <?php echo isset($pms['reload']) && $pms['reload'] > 0 ? $pms['reload'] * 1000 : 2000; ?>);
        }
    }

    jQuery(function ($) {

        $('#mlimit').tooltip();

        WPDMPM.refreshAllMsg();

        WPDMPM.refreshInbox();

        WPDMPM.refreshSent();

        WPDMPM.checkNewMessage();

        var $body = $('body');


        $('a[data-toggle="tab"]').on('click', function () {
            $('.tab-pane').removeClass('show active');
            $($(this).attr('href')).removeClass('fade').addClass('show active');
        });

        $body.on('click', '.list-group-item', function () {
            $('.btn.btn-info.btn-lg.btn-block.active').removeClass('active');
        });
        $body.on('click', '.btn.btn-info.btn-lg.btn-block', function () {
            $('.list-group-item.active').removeClass('active');
        });

        $body.on('keyup', '#email-request', function (event) {

            var search = $(this).val();

            if (search.length < 2) return;

            $.ajax(wpdmpmAPI.users, {
                method: 'GET',
                data: {keyword: search},
                beforeSend: function (xhr) {
                    xhr.setRequestHeader('X-WP-Nonce', wpdmpmAPI.nonce);
                }
            }).done(function (data) {
                if (data.length > 0)
                    $('#wpdmpm-sugestions').fadeIn();
                else
                    $('#wpdmpm-sugestions').fadeOut();
                searchusers.suggestions = data;
            });
        });

        $(document).mouseup(function (e) {
            var container = $('#wpdmpm-sugestions');
            if (!container.is(e.target) && container.has(e.target).length === 0) container.hide();
        });

        $body.on('click', '#wpdmpm-sugestions a', function (e) {
            e.preventDefault();
            //$('#email-request').val(this.rel);
            $('#selected-member').append("<div   style='padding: 10px;margin: 5px;display: inline-block;border: 1px solid #ddd;' id='msel_" + $(this).attr('rel') + "'><div class='media'><input type='hidden' name='send_to[]' value='" + $(this).attr('rel') + "'/><div class='mr-2'><img style='width: 24px' src='" + $(this).attr('data-pic') + "' alt='Profile Pic' /></div><div class='media-body'>" + $(this).attr('data-name') + "</div><div class='ml-3'><i class='fa fa-times-circle text-danger c-pointer remove_msel' data-uid='" + $(this).attr('rel') + "'></i></div></div></div>");
            $('#wpdmpm-sugestions').fadeOut();
            $('#member_selector').hide();
        });

        $body.on('click', '.remove_msel', function () {
            $('#msel_' + $(this).data('uid')).remove();
        });

        $body.on('click', '.remove_received_message,.remove_received_message_admin', function (event) {
            event.preventDefault();
            if (!confirm('Are you sure?')) return false;
            var pid = $(this).attr('rel');

            $(this).find('.fas').removeClass('fa-trash text-muted').addClass('fa-sun fa-spin color-red');
            let endpoint = '';
            if ($(event.target).hasClass('remove_received_message_admin') || $(event.target).closest('a').hasClass('remove_received_message_admin')) {
                endpoint = wpdmpmAPI.delete_message_admin
            } else {
                endpoint = wpdmpmAPI.delete_message
            }

            $.ajax(endpoint, {
                method: 'POST',
                data: {id: pid},
                beforeSend: function (xhr) {
                    xhr.setRequestHeader('X-WP-Nonce', wpdmpmAPI.nonce);
                }
            }).done(function (data) {
                $('#delete_received_message_row_' + pid).remove();
                $('#delete_sent_message_row_' + pid).remove();
                $('#delete_all_message_row_' + pid).remove();
            });
        });

        $body.on('click', '.wpdmpm-open', function (event) {
            event.preventDefault();
            var id = $(this).attr('rel');

            $('.tab-pane').removeClass('show active');
            $('#viewmessage').addClass('show active');

            if ($(this).hasClass('wpdmpm-status-new'))
                $(this).removeClass('wpdmpm-status-new').addClass('wpdmpm-status-read');

            //$('#viewmessage').tab('show');
            $('#msg-cont').css('min-height', '400px').addClass('blockui');
            $.ajax(wpdmpmAPI.get_message, {
                method: 'GET',
                data: {id: id},
                beforeSend: function (xhr) {
                    xhr.setRequestHeader('X-WP-Nonce', wpdmpmAPI.nonce);
                }
            }).done(function (data) {
                message.message = data;
                $('#msg-cont').removeClass('blockui');
                if (!$wppmsg_reply_attachment)
                    wppmsg_reply_attachment();
            });


        });

        $body.on('submit', '#post_reply', function (e) {
            e.preventDefault();
            $('#post_reply').addClass('blockui');
            var msgid = $('#message_id').val();
            $(this).ajaxSubmit({
                url: wpdmpmAPI.create_reply,
                beforeSubmit: function (arr, $form, options) {
                    options.headers = {'X-WP-Nonce': wpdmpmAPI.nonce}
                },
                success: function (res) {
                    if (res.error === true)
                        WPPMSG.notify("<b>Error!</b> " + res.message, "error");
                    else {
                        WPPMSG.notify("<b>Success!</b> Reply Sent", "success");
                        $('.form-control').each(function () {
                            $(this).val('');
                        });
                        WPDMPM.refreshSent();

                    }
                    message.newra = [];
                    $('#post_reply').removeClass('blockui');
                    $('#msg-cont').addClass('blockui');
                    $.ajax(wpdmpmAPI.get_message, {
                        method: 'GET',
                        data: {id: msgid, skip_status: 1},
                        beforeSend: function (xhr) {
                            xhr.setRequestHeader('X-WP-Nonce', wpdmpmAPI.nonce);
                        }
                    }).done(function (data) {
                        message.message = data;
                        $('#msg-cont').removeClass('blockui');
                    });

                },
                error: function (error) {
                    console.log(error.responseText);
                }
            });
            return false;
        });

        var pushids = <?php echo json_encode(get_user_meta(get_current_user_id(), '__wpdm_onesignal_player_id')); ?>;

        if (typeof OneSignal !== "undefined") {
            try {
                OneSignal.getUserId(function (id) {
                    if (!JSON.stringify(pushids).indexOf(id)) {
                        $.post(wpdmpmAPI.ajax_url, {
                            action: 'wpdm_onesignal_player_id',
                            __wpdm_onesignal_player_id: id
                        }, function (res) {

                        });
                    }
                });
            } catch (e) {
                console.log(e);
            }
        }

    });


</script>
<script>

    function wppmsg_reply_attachment() {
        $wppmsg_reply_attachment = 1;
        <?php

        $plupload_init = array(
            'runtimes' => 'html5,silverlight,flash,html4',
            'browse_button' => 'wpdm-browse-button-reply',
            'container' => 'wpdm-upload-ui-reply',
            'drop_element' => 'wpdm-drag-drop-area-reply',
            'file_data_name' => 'wpdmpm_file',
            'multiple_queues' => false,
            'url' => admin_url('admin-ajax.php'),
            'flash_swf_url' => includes_url('js/plupload/plupload.flash.swf'),
            'silverlight_xap_url' => includes_url('js/plupload/plupload.silverlight.xap'),
            'filters' => array(array('title' => __('Allowed Files'), 'extensions' => get_option('__wpdm_allowed_file_types', 'png,pdf,jpg,jpeg,doc,ppt,docx,txt'))),
            'multipart' => true,
            'urlstream_upload' => true,

            // additional post data to send to our ajax hook
            'multipart_params' => array(
                '_ajax_nonce' => wp_create_nonce(NONCE_KEY),
                'action' => '__wpdmpm_attach_file',            // the ajax action name
            ),
        );

        $plupload_init['max_file_size'] = wp_max_upload_size() . 'b';

        // we should probably not apply this filter, plugins may expect wp's media uploader...
        $plupload_init = apply_filters('plupload_init', $plupload_init);
        ?>
        jQuery(function ($) {


            var r_uploader = new plupload.Uploader(<?php echo json_encode($plupload_init); ?>);

            r_uploader.bind('Init', function (up) {
                var uploaddiv = $('#wpdm-upload-ui-reply');

                if (up.features.dragdrop) {
                    uploaddiv.addClass('drag-drop');
                    $('#drag-drop-area-reply')
                        .bind('dragover.wp-uploader', function () {
                            uploaddiv.addClass('drag-over');
                        })
                        .bind('dragleave.wp-uploader, drop.wp-uploader', function () {
                            uploaddiv.removeClass('drag-over');
                        });

                } else {
                    uploaddiv.removeClass('drag-drop');
                    $('#drag-drop-area-reply').unbind('.wp-uploader');
                }
            });

            r_uploader.init();

            r_uploader.bind('Error', function (uploader, error) {
                wppmsg_bootModal('Error', error.message);
                $('#wmprogressbar-reply').hide();
                $('#wpdm-browse-button-reply').show();
            });


            r_uploader.bind('FilesAdded', function (up, files) {
                $('#file__attachments-reply').slideDown();
                $('#wpdm-browse-button-reply').hide();
                $('#wmprogressbar-reply').show();

                plupload.each(files, function (file) {
                    $('#wmprogress-reply').css('width', file.percent + "%");
                    $('#wmloaded-reply').html(file.percent);
                });

                up.refresh();
                up.start();
            });

            r_uploader.bind('UploadProgress', function (up, file) {
                $('#wmprogress-reply').css('width', file.percent + "%");
                $('#wmloaded-reply').html(file.percent);
            });


            r_uploader.bind('FileUploaded', function (up, file, response) {
                res = JSON.parse(response.response);
                message.newra.push(res);
                $('#wmprogressbar-reply').hide();
                $('#wpdm-browse-button-reply').show();


            });


        });
    }

</script>
