<?php

use PrivateMessage\__\__Template;

if (!defined("ABSPATH")) die();
$current_user = wp_get_current_user();
$mlimit = PrivateMessage\__\__::valueof(PrivateMessage()->settings->general->pm_limit, array_values($current_user->roles)[0]);
$mlimit = $mlimit > 0 ?: __('Unlimited', PM_TEXT_DOMAIN);

/*Count messages sent by current user*/
$authorid = get_current_user_id();
$user_msg_count = 0;
$user_msg_count = count_user_posts($authorid, 'message');
$user = get_user_by("id", $authorid);
if ($mlimit === 'Unlimited')
    $percent = 0;
else
    $percent = $mlimit > 0 ? $user_msg_count * 100 / $mlimit : 0;

?>
<style>
    .w3eden .profile-card img.avatar {
        max-width: calc(100% - 60px);
        margin: 30px;
        border-radius: 500px;
        height: auto;
    }

    @media (max-width: 1440px) {
        .w3eden .profile-card img.avatar {
            max-width: calc(100% - 20px);
            margin: 10px;
        }
    }

    .w3eden .card h3 {
        font-size: 13pt;
        margin: 5px 0;
    }

    .w3eden .card {
        padding: 0;
        margin: 0;
    }

    #pmsidebar a {
        font-size: 14px;
        font-weight: 400;
        padding: 0 20px;
        line-height: 46px;
        height: 48px;
    }

    #pmsidebar a.list-group-item {
        color: var(--color-secondary);
    }

    .sechead {
        margin: 0 0 15px 0 !important;
        font-size: 14pt;
        line-height: normal;
        font-weight: bold;
        border-bottom: 1px solid #eeeeee;
        padding-bottom: 10px;

    }

    .wp-editor-tabs button {
        font-size: 12px;
    }

    #message_ifr {
        min-height: 250px !important;
    }

    .title-icon {
        margin-top: 2px;
        margin-right: 5px;
    }

    .table td {
        border-color: #eeeeee !important;
        text-align: left;
    }

    .table {
        margin: 0 !important;
    }

    .list-group a .fas {
        margin-right: 5px !important;
    }

    #mlimit {
        position: relative;
    }

    .pull-right #mlimit {
        margin: 0;
        width: 200px;
        height: 37px;
        border-radius: 3px !important;
    }

    #mlimit .progress-bar {
        background-color: #8f6fd5;
    }

    label.input-group-addon {
        cursor: pointer;
    }

    .panel-body p {
        margin-bottom: 10px;
    }

    .panel-body p:last-child {
        margin-bottom: 0;
    }

    .w3eden a.wpdmpm-open,
    .w3eden a.wpdmpm-status-read {
        color: #90979c;
    }

    .w3eden a.wpdmpm-status-new {
        color: #4280de;
    }

    .w3eden .tab-content {
        padding: 0;
        border: 0;
    }

    .tab-content .fade.in {
        background: transparent !important;
    }

    .media.attachment-single {
        font-size: 9pt;
        font-weight: 400;
        margin: 0;
        line-height: 1.6;
    }

    .w3eden .contact-avatar {
        width: 48px;
        height: 48px;
        border-radius: 500px;
    }

    .w3eden .table .contact td {
        vertical-align: middle !important;
    }

    .w3eden .table .contact h3 {
        font-size: 12pt;
        font-weight: 800;
        line-height: 1;
        margin: 5px 0 0;
    }

    .w3eden .table .contact em {
        font-size: 12px;
    }
</style>
<div class="w3eden">
    <div class="main-content pm-content">

        <!-- Widget Stats -->
        <div class="row">

            <?php if (!isset($params['menu']) || $params['menu'] === 'left') { ?>
                <div class="col-md-3" id="pmsidebar">
                    <?php //if((int)wpdm_valueof($params, 'profile_card') === 1){ ?>
                    <div class="card mb-3">
                        <div class="card-body p-0">
                            <img class="m-0 p-0" src="<?= get_avatar_url($authorid, ['size' => 512]); ?>" alt="Avatar"/>
                        </div>
                        <div class="card-footer bg-white">
                            <strong><?= sprintf(__('Welcome, %s', PM_TEXT_DOMAIN), $user->display_name); ?></strong>
                        </div>
                    </div>
                    <?php //} ?>
                    <a class="btn btn-primary btn-lg btn-block" style="margin-bottom: 15px" href="#compose"
                       data-toggle="tab" aria-expanded="true"><i
                                class="fas fa-pen-square mr-2"></i> <?php _e('Compose', PM_TEXT_DOMAIN) ?></a>

                    <div class="list-group">
                        <a class="list-group-item d-flex justify-content-between align-items-center active"
                           href="#inbox" data-toggle="tab" aria-expanded="false"><span><i
                                        class="fas fa-inbox color-primary"></i> <?php _e('Inbox', PM_TEXT_DOMAIN) ?></span>
                            <span class="badge badge-danger" id="inboxunread">0</span></a>
                        <a class="list-group-item" href="#sent" data-toggle="tab"><i
                                    class="fas fa-paper-plane color-primary"></i> <?php _e('Sent', PM_TEXT_DOMAIN) ?>
                        </a>
                        <a class="list-group-item" href="#contacts" data-toggle="tab"><i
                                    class="fas fa-user-circle color-primary"></i> <?php _e('Contacts', PM_TEXT_DOMAIN) ?>
                        </a>
                        <a class="list-group-item" href="#wppmsgsettings" data-toggle="tab"><i
                                    class="fas fa-cog color-primary"></i> <?php _e('Settings', PM_TEXT_DOMAIN) ?></a>
                        <a class="list-group-item"
                           href="<?= \PrivateMessage\__\__::logout_url($_SERVER['REQUEST_URI']); ?>"><i
                                    class="fas fa-sign-out-alt color-red"></i> <?php _e('Logout', PM_TEXT_DOMAIN) ?></a>
                    </div>

                    <br/>

                    <div id="mlimit" data-toggle="tooltip" class="progress" style="margin: 0"
                         title="<?php _e('Sending Limit', PM_TEXT_DOMAIN) ?> ( <?php echo $user_msg_count; ?> / <?php echo $mlimit; ?> )">
                        <div class="progress-bar " style="width: <?php echo $percent; ?>%;"></div>
                    </div>

                </div>
            <?php } ?>

            <?php if (isset($params['menu']) && $params['menu'] === 'top') { ?>
                <div class="col-md-12 pb-4">

                    <div class="pull-right float-right">
                        <div id="mlimit" data-toggle="tooltip" class="progress" style="margin: 0"
                             title="<?php _e('Sending Limit', PM_TEXT_DOMAIN) ?> ( <?php echo $user_msg_count; ?> / <?php echo $mlimit; ?> )">
                            <div style="font-size: 9px;position: absolute;width: 100%;line-height: 37px;text-align: center;z-index: 999999;color: rgba(0,0,0,0.5)"><?php _e('Sending Limit', PM_TEXT_DOMAIN) ?>
                                ( <?php echo $user_msg_count; ?> / <?php echo $mlimit; ?> )
                            </div>
                            <div class="progress-bar " style="width: <?php echo $percent; ?>%;"></div>
                        </div>
                    </div>

                    <a class="btn btn-info btn-simple tab-btn" href="#compose"
                       style="margin-right: 15px;border-width: 1px" data-toggle="tab" aria-expanded="true"><i
                                class="fas fa-pen-square"></i> <?php _e('Compose', PM_TEXT_DOMAIN) ?></a>
                    <div class="btn-group">
                        <a class="btn tab-btn btn-primary btn-simple active" href="#inbox" data-toggle="tab" role="tab"
                           aria-controls="inbox" aria-selected="true"><i
                                    class="fas fa-inbox"></i> <?php _e('Inbox', PM_TEXT_DOMAIN) ?></a>
                        <a class="btn tab-btn btn-primary btn-simple" href="#sent" data-toggle="tab"
                           aria-controls="sent" aria-selected="true"><i
                                    class="fas fa-paper-plane"></i> <?php _e('Sent', PM_TEXT_DOMAIN) ?></a>
                    </div>


                </div>
            <?php } ?>
            <div class="col-md-<?php echo (!isset($params['menu']) || $params['menu'] === 'left') ? 9 : 12; ?>">

                <div class="tab-content">
                    <div class="tab-pane active" id="inbox">

                        <!-- Inbox Tab -->

                        <?php
                        include __Template::locate("received-message.php", __DIR__);
                        ?>

                        <!--/ Inbox Tab -->

                    </div>
                    <div class="tab-pane fade" id="compose">

                        <!-- Compose Tab -->

                        <?php
                        include __Template::locate("message-form.php", __DIR__);
                        ?>

                        <!--/ Compose Tab -->
                    </div>
                    <div class="tab-pane fade" id="sent">

                        <?php
                        include __Template::locate("sent-message.php", __DIR__);
                        ?>

                    </div>

                    <div class="tab-pane fade" id="viewmessage">
                        <?php
                        include __Template::locate("open-message.php", __DIR__);
                        ?>
                    </div>

                    <div class="tab-pane fade" id="contacts">

                        <?php
                        echo do_shortcode("[wppmsg_contacts]");
                        ?>

                    </div>

                    <div class="tab-pane fade" id="wppmsgsettings">

                        <?php
                        echo do_shortcode("[wppmsg_edit_profile]");
                        ?>

                    </div>

                </div>

            </div>


        </div>
    </div>
</div>

<?php
/* Restore original Post Data */
wp_reset_postdata();
?>
<!--<script src="https://cdn.jsdelivr.net/npm/vue"></script>-->
<script>


    var $ = jQuery, $wppmsg_reply_attachment = 0;

    Vue.component('link-preview', {
        data() {
            return {
                preview: null,
                elementVisible: true
            }
        },
        props: ['url'],
        mounted() {
            var vm = this;
            jQuery.ajax(wpdmpmAPI.get_link_meta, {
                method: 'GET',
                data: {url: vm.url},
                beforeSend: function (xhr) {
                    xhr.setRequestHeader('X-WP-Nonce', wpdmpmAPI.nonce);
                }
            }).done(function (data) {
                vm.preview = null;
                vm.preview = data;
            });
            setTimeout(() => vm.elementVisible = false, 3000)

        },
        methods: {
            removePreview: function (event) {
                jQuery(event.target).closest('.card').remove();
            }
        },
        template: `<div v-if="preview" class="card mt-1" :key="preview.title"
                         style="width: 18rem; position: relative;">
                        <i v-on:click="removePreview" style="position: absolute;right: 5px;top:5px;" class="fas fa-window-close"></i>
                        <img style="height: 100px;object-fit: cover;" class="card-img-top"
                             v-bind:src="preview.img_src" alt="Card image cap">
                        <div class="card-body">
                            <a target="_blank" v-bind:href="preview.url" class="card-title" v-html="preview.title"></a>
                        </div>
                    </div>
                    <div v-else v-show="elementVisible" class="card justify-content-center mt-1" style="width: 18rem; height: 9rem; position: relative;">
                        <i v-on:click="removePreview" style="position: absolute;right: 5px;top:5px;" class="fas fa-window-close"></i>
                        <i style="width: 1em;" class="fa-2x fas fa-spinner fa-pulse m-auto"></i>
                    </div>`
    })


    var inbox = new Vue({
        el: '#inbox-table',
        data: {
            messages: []
        }
    });

    var sent = new Vue({
        el: '#sent-table',
        data: {
            messages: []
        }
    });

    var message = new Vue({
        el: '#msg-cont',
        data: {
            message: [],
            newra: [],
            previews: []
        }
    });

    var __attached_files = new Vue({
        el: '#__attached_files',
        data: {
            files: []
        }
    });

    var searchusers = new Vue({
        el: '#wpdmpm-sugestions',
        data: {
            suggestions: [{
                name: '<?php _e('Start Typing', PM_TEXT_DOMAIN) ?>',
                email: '<?php _e('to see the sugestions...', PM_TEXT_DOMAIN) ?>'
            }]
        }
    });


    WPPMSG.audio = "<?php echo PM_ASSET_URL . "sounds/filling-your-inbox.mp3"; ?>";

    class WPDMPM {

        static refreshInbox() {
            jQuery.ajax(wpdmpmAPI.get_messages, {
                method: 'GET',
                beforeSend: function (xhr) {
                    xhr.setRequestHeader('X-WP-Nonce', wpdmpmAPI.nonce);
                }
            }).done(function (data) {
                inbox.messages = data
            });
        }

        static refreshSent() {
            jQuery.ajax(wpdmpmAPI.get_messages, {
                method: 'GET',
                data: {folder: "sent"},
                beforeSend: function (xhr) {
                    xhr.setRequestHeader('X-WP-Nonce', wpdmpmAPI.nonce);
                }
            }).done(function (data) {
                sent.messages = data
            });
        }

        static checkNewMessage() {

            jQuery.ajax(wpdmpmAPI.check_new_message, {
                method: 'GET',
                beforeSend: function (xhr) {
                    xhr.setRequestHeader('X-WP-Nonce', wpdmpmAPI.nonce);
                }
            }).done(function (data) {
                if (data.new_message) {
                    //WPPMSG.notify("<b>"+data.new_message+"</b> new message(s) in your inbox!")
                    WPPMSG.pushNotify("New Message", "You have " + data.new_message + " new message!", "https://cdn2.iconfinder.com/data/icons/black-friday-shopping-3/228/Asset_1120-512.png", "https://cdn1.iconfinder.com/data/icons/hawcons/32/699318-icon-47-note-important-128.png", location.href);
                    WPPMSG.beep();
                    WPDMPM.refreshInbox();
                }
                $('#inboxunread').html(data.unread);
                setTimeout("WPDMPM.checkNewMessage()", <?php echo PrivateMessage()->settings->general->pm_check_interval > 0 ? PrivateMessage()->settings->general->pm_check_interval * 1000 : 4000; ?>);
            });
        }
    }

    jQuery(function ($) {

        $('#mlimit').tooltip();

        $('a[data-toggle="tab"]').on('click', function () {
            $('.tab-pane').removeClass('show active');
            $($(this).attr('href')).removeClass('fade').addClass('show active');
        });

        var $body = $('body');

        $body.on('click', '.list-group-item', function () {
            $('.btn.btn-primary.btn-lg.btn-block.active').removeClass('active');
        });
        $body.on('click', '.btn.btn-primary.btn-lg.btn-block', function () {
            $('.list-group-item.active').removeClass('active');
        });

        WPDMPM.refreshInbox();

        WPDMPM.refreshSent();

        WPDMPM.checkNewMessage();

        $('.tab-btn').on('click', function () {
            $('.tab-btn').removeClass('active');
            $(this).addClass('active');
            $('.tab-content .tab-pane').removeClass('show active');
            $($(this).attr('href')).addClass('show active');
        });


        $body.on('keyup', '#email-request', function (event) {

            var search = $(this).val();

            if (search.length < 2) return;

            $.ajax(wpdmpmAPI.users, {
                method: 'GET',
                data: {keyword: search},
                beforeSend: function (xhr) {
                    xhr.setRequestHeader('X-WP-Nonce', wpdmpmAPI.nonce);
                }
            }).done(function (data) {
                if (data.length > 0)
                    $('#wpdmpm-sugestions').fadeIn();
                else
                    $('#wpdmpm-sugestions').fadeOut();
                searchusers.suggestions = data;
            });
        });

        $(document).mouseup(function (e) {
            var container = $('#wpdmpm-sugestions');
            if (!container.is(e.target) && container.has(e.target).length === 0) container.hide();
        });

        $body.on('click', '#wpdmpm-sugestions a', function (e) {
            e.preventDefault();
            //var _avatar = '<img style="width: 24px" src="'+$(this).data('pic')+'" alt="Profile Pic" />';
            var _avatar = "";
            $('#selected-member').html("<div class='card p-3 mt-2 mb-2'><div class='media'><input type='hidden' name='send_to' value='" + $(this).attr('rel') + "'/><div class='mr-3'>" + _avatar + "</div><div class='media-body'>" + $(this).data('name') + "</div><div class='ml-3'><i class='fa fa-times-circle text-danger c-pointer' id='remove_msel'></i></div></div></div>");
            $('#wpdmpm-sugestions').fadeOut();
            $('#member_selector').hide();

        });

        $body.on('click', '#remove_msel', function () {
            $('#selected-member').html('');
            $('#member_selector').show();
        });

        $body.on('click', '.remove_received_message', function (event) {
            event.preventDefault();
            if (!confirm('Are you sure?')) return false;
            var pid = $(this).attr('rel');

            $(this).find('.fas').removeClass('fa-trash text-muted').addClass('fa-sun fa-spin color-red');

            $.ajax(wpdmpmAPI.delete_message, {
                method: 'POST',
                data: {id: pid},
                beforeSend: function (xhr) {
                    xhr.setRequestHeader('X-WP-Nonce', wpdmpmAPI.nonce);
                }
            }).done(function (data) {
                $('#delete_received_message_row_' + pid).remove();
            });
        });

        $body.on('click', '.wpdmpm-open', function (event) {
            event.preventDefault();
            var id = $(this).attr('rel');

            $('.tab-content .tab-pane').removeClass('show active');
            $($(this).attr('href')).addClass('show active');

            if ($(this).hasClass('wpdmpm-status-new'))
                $(this).removeClass('wpdmpm-status-new').addClass('wpdmpm-status-read');

            //$('#viewmessage').tab('show');
            $('#msg-cont').css('min-height', '400px').addClass('blockui');
            $.ajax(wpdmpmAPI.get_message, {
                method: 'GET',
                data: {id: id},
                beforeSend: function (xhr) {
                    xhr.setRequestHeader('X-WP-Nonce', wpdmpmAPI.nonce);
                }
            }).done(function (data) {
                message.message = data;
                $('#msg-cont').removeClass('blockui');
                if (!$wppmsg_reply_attachment)
                    setTimeout("wppmsg_reply_attachment", 2000);
            });
        });

        $body.on('click', '#wpdm-browse-button-reply', function (event) {
            if (!$wppmsg_reply_attachment) {
                wppmsg_reply_attachment();
            }
        });

        $body.on('submit', '#post_reply', function (e) {
            e.preventDefault();
            $('#post_reply').addClass('blockui');
            var msgid = $('#message_id').val();
            $(this).ajaxSubmit({
                url: wpdmpmAPI.create_reply,
                beforeSubmit: function (arr, $form, options) {
                    options.headers = {'X-WP-Nonce': wpdmpmAPI.nonce}
                },
                success: function (res) {
                    console.log(res);
                    if (res.success === false)
                        WPPMSG.notify("<b>Error!</b> " + res.message, "error");
                    else {
                        WPPMSG.notify("<b>Success!</b> Reply Sent", "success");
                        $('.form-control').each(function () {
                            $(this).val('');
                        });
                        WPDMPM.refreshSent();

                    }
                    message.newra = [];
                    $('#post_reply').removeClass('blockui');
                    $('#msg-cont').addClass('blockui');
                    $.ajax(wpdmpmAPI.get_message, {
                        method: 'GET',
                        data: {id: msgid, skip_status: 1},
                        beforeSend: function (xhr) {
                            xhr.setRequestHeader('X-WP-Nonce', wpdmpmAPI.nonce);
                        }
                    }).done(function (data) {
                        message.message = data;
                        $('#msg-cont').removeClass('blockui');
                    });

                },
                error: function (error) {
                    console.log(error.responseText);
                }
            });
            return false;
        });

        $body.on('click', '.remove-contact', function (e) {
            e.preventDefault();
            var btn = $(this);
            btn.attr('disabled', 'disabled');
            $.ajax({
                url: wpdmpmAPI.remove_contact,
                data: {user: $(this).data('user')},
                type: "GET",
                beforeSend: function (xhr) {
                    xhr.setRequestHeader('X-WP-Nonce', wpdmpmAPI.nonce);
                },
                success: function (response) {
                    btn.remove();
                }
            });
        });

        /*$body.on('click', 'tr.contact', function (e){
            e.preventDefault();
            $.ajax({
                url: wpdmpmAPI.user_profile,
                data: {user: $(this).data('user')},
                type: "GET",
                beforeSend: function ( xhr ) {
                    xhr.setRequestHeader('X-WP-Nonce', wpdmpmAPI.nonce);
                },
                success: function(profile) {
                    _user.profile = profile;
                }
            });
        });*/

        var pushids = <?php echo json_encode(get_user_meta(get_current_user_id(), '__wpdm_onesignal_player_id')); ?>;

        if (typeof OneSignal !== "undefined") {
            try {
                OneSignal.getUserId(function (id) {
                    if (!JSON.stringify(pushids).indexOf(id)) {
                        $.post(wpdmpmAPI.ajax_url, {
                            action: 'wpdm_onesignal_player_id',
                            __wpdm_onesignal_player_id: id
                        }, function (res) {

                        });
                    }
                });
            } catch (e) {
                console.log(e);
            }
        }

    });


</script>

<script>

    function wppmsg_reply_attachment() {
        <?php

        $plupload_init = array(
            'runtimes' => 'html5,silverlight,flash,html4',
            'browse_button' => 'wpdm-browse-button-reply',
            'container' => 'wpdm-upload-ui-reply',
            'drop_element' => 'wpdm-drag-drop-area-reply',
            'file_data_name' => 'wpdmpm_file',
            'multiple_queues' => false,
            'url' => admin_url('admin-ajax.php'),
            'flash_swf_url' => includes_url('js/plupload/plupload.flash.swf'),
            'silverlight_xap_url' => includes_url('js/plupload/plupload.silverlight.xap'),
            'filters' => array(array('title' => __('Allowed Files'), 'extensions' => get_option('__wpdm_allowed_file_types', 'png,pdf,jpg,jpeg,doc,ppt,docx,txt'))),
            'multipart' => true,
            'urlstream_upload' => true,

            // additional post data to send to our ajax hook
            'multipart_params' => array(
                '_ajax_nonce' => wp_create_nonce(NONCE_KEY),
                'action' => '__wpdmpm_attach_file'
            )
        );

        $plupload_init['max_file_size'] = wp_max_upload_size() . 'b';

        // we should probably not apply this filter, plugins may expect wp's media uploader...
        $plupload_init = apply_filters('plupload_init', $plupload_init);
        ?>
        jQuery(function ($) {


            var r_uploader = new plupload.Uploader(<?php echo json_encode($plupload_init); ?>);

            r_uploader.bind('Init', function (up) {
                var uploaddiv = $('#wpdm-upload-ui-reply');

                if (up.features.dragdrop) {
                    uploaddiv.addClass('drag-drop');
                    $('#drag-drop-area-reply')
                        .bind('dragover.wp-uploader', function () {
                            uploaddiv.addClass('drag-over');
                        })
                        .bind('dragleave.wp-uploader, drop.wp-uploader', function () {
                            uploaddiv.removeClass('drag-over');
                        });

                } else {
                    uploaddiv.removeClass('drag-drop');
                    $('#drag-drop-area-reply').unbind('.wp-uploader');
                }
                $wppmsg_reply_attachment = 1;
            });

            r_uploader.init();

            r_uploader.bind('Error', function (uploader, error) {
                wppmsg_bootModal('Error', error.message);
                $('#wmprogressbar-reply').hide();
                $('#wpdm-browse-button-reply').show();
            });


            r_uploader.bind('FilesAdded', function (up, files) {
                $('#file__attachments-reply').slideDown();
                $('#wpdm-browse-button-reply').hide();
                $('#wmprogressbar-reply').show();

                plupload.each(files, function (file) {
                    $('#wmprogress-reply').css('width', file.percent + "%");
                    $('#wmloaded-reply').html(file.percent);
                });

                up.refresh();
                up.start();
            });

            r_uploader.bind('UploadProgress', function (up, file) {
                $('#wmprogress-reply').css('width', file.percent + "%");
                $('#wmloaded-reply').html(file.percent);
            });


            r_uploader.bind('FileUploaded', function (up, file, response) {
                res = JSON.parse(response.response);
                message.newra.push(res);
                $('#wmprogressbar-reply').hide();
                $('#wpdm-browse-button-reply').show();


            });


        });
    }

</script>
