<?php
if (!defined("ABSPATH")) die();
global $product;

if (class_exists('WooCommerce') && isset($product)) {
    $id = $product->get_id();
    $title = $product->get_title();
    $link = $product->get_permalink();
    $product_description = strip_shortcodes(get_the_excerpt( $id));
    $product_image = wp_get_attachment_image_src(get_post_thumbnail_id($id), 'single-post-thumbnail');
    $woocommerce_attrs = 'data-product_id=' . $id . ' data-product_title=' . $title . ' data-product_link=' . $link . ' data-product_image=' . $product_image[0];;
}
?>
<div class="w3eden d-inline-block">
    <button <?php if (isset($woocommerce_attrs)) echo $woocommerce_attrs; ?>
            class="btn btn-<?= PrivateMessage\__\__::valueof($params, 'color', ['default' => 'primary']); ?>"
            data-target="#wppmsg-to-author" data-user="<?php echo \PrivateMessage\__\__Crypt::encrypt($author); ?>"
            data-title="<?= PrivateMessage\__\__::valueof($params, 'title', ['default' => __('Send Private Message', PM_TEXT_DOMAIN)]); ?>"
            data-toggle="modal">
        <i class="<?= PrivateMessage\__\__::valueof($params, 'icon', ['default' => 'fas fa-envelope']); ?>"></i>
        <?= PrivateMessage\__\__::valueof($params, 'label', ['default' => 'PM TO AUTHOR']); ?>
    </button>
    <?= isset($product_description) ? '<input type="hidden" id="wppm_product_description" value="' . $product_description . '"/>' : ''; ?>
</div>