<?php


namespace PrivateMessage\Notice;


use PrivateMessage\__\__;

class Notice
{
    public $id;
    public $name;
    public $content;
    public $position;
    public $width;
    public $margin;
    public $padding;
    public $bgColor;
    public $txtColor;
    public $borderRadius;
    public $noticeActionButtonBackgrond;
    public $noticeActionButtonColor;
    public $fontFamily;
    public $fontSize;
    public $buttonURL = '';
    public $buttonLabel = '';
    public $buttonStyle = '';
    public $dismissable = true;
    public $dismissaction = false;
    public $show = true;
    public $resetKey;
    public $start;
    public $end;
    function __construct($id = null)
    {
        if($id)
        {
            $_notice = get_post($id);
            $this->id = $_notice->ID;
            $this->name = $_notice->post_title;
            $this->content = do_shortcode(wpautop($_notice->post_content));
            $_notice_meta = get_post_meta($id, '__wppm_notice', true);
            $this->start = strtotime(__::valueof($_notice_meta, 'activation/start_date'));
            $this->start = $this->start ? $this->start : time() + 999999;
            $this->end = strtotime(__::valueof($_notice_meta, 'activation/end_date'));
            $this->end = $this->end ? $this->end : time() + 999999;
            // || _time < this.notices[id].end || _time > this.notices[id].start
            $this->show = time() < $this->end && $this->start < time();
            $this->position = __::valueof($_notice_meta, 'ui/position');
            $this->width = __::valueof($_notice_meta, 'ui/width', ['validate' => 'int']);
            $this->width = $this->width ? $this->width .'px' : '100%';
            $this->margin = __::valueof($_notice_meta, 'ui/margin', ['validate' => 'int']);
            $this->padding = __::valueof($_notice_meta, 'ui/padding', ['validate' => 'int']);
            $this->bgColor = __::valueof($_notice_meta, 'ui/bgcolor');
            $this->txtColor = __::valueof($_notice_meta, 'ui/txtcolor');
            $this->borderRadius = __::valueof($_notice_meta, 'ui/radius', ['validate' => 'int']);
            $this->noticeActionButtonBackgrond = __::valueof($_notice_meta, 'ui/btn_background');
            $this->noticeActionButtonColor = __::valueof($_notice_meta, 'ui/btn_text_color');
            $this->fontFamily = __::valueof($_notice_meta, 'ui/fontfamily', ['validate' => 'str']);
            $this->fontSize = __::valueof($_notice_meta, 'ui/fontsize', ['validate' => 'int']);
            $this->buttonURL = __::valueof($_notice_meta, 'action/button_url');
            $this->buttonLabel = __::valueof($_notice_meta, 'action/button_label');
            $this->buttonStyle = __::valueof($_notice_meta, 'action/button_style');
            $this->dismissable = __::valueof($_notice_meta, 'action/dismissable');
            $this->dismissaction = __::valueof($_notice_meta, 'action/dismissaction');
            $this->resetKey = __::valueof($_notice_meta, 'reset_key', ['default' => $_notice->ID]);
        }
    }

    static function get($id)
    {
        $notice = new Notice($id);
        return $notice;
    }

    function getAll()
    {
        $_notices = get_posts(['post_type' => 'notice']);
        $notices = [];
        foreach ($_notices as $notice)
        {
            $notices[$notice->ID] = new Notice($notice->ID);
        }
        $notices = apply_filters("wppm_notices", $notices);
        //wpdmdd($notices);
        return $notices;
    }
}