<?php


namespace PrivateMessage\Notice;

if(!defined("ABSPATH")) die("Shit happens!");

define("NOTICE_BASE_DIR", __DIR__);

use PrivateMessage\__\__;
use PrivateMessage\__\__Crypt;
use PrivateMessage\__\__FileSystem;
use PrivateMessage\__\__Email;
use PrivateMessage\__\__MailUI;
use PrivateMessage\__\__Messages;
use PrivateMessage\__\__Template;

class NoticeController extends __
{

    private static $instance;
    public $count = 0;

    public static function getInstance()
    {
        if (self::$instance === null) {
            self::$instance = new self;
        }
        return self::$instance;
    }

    private function __construct()
    {
        new RestAPI();

        add_action("admin_menu", [$this, "adminMenu"]);
        add_action("wp_footer", [$this, "showNotice"]);
        add_action( 'add_meta_boxes', [$this, 'metaBoxes'] );
        add_action( 'save_post', [$this, 'saveNotice'], 10, 3 );
        add_action( 'admin_enqueue_scripts', [$this, 'adminEnqueueScripts'], 10, 3 );

        add_action('manage_notice_posts_columns', array($this, 'columnsTH'));
        add_action('manage_notice_posts_custom_column', array($this, 'columnsTD'), 10, 2);

    }

    function adminEnqueueScripts($hook)
    {

        if(get_post_type() !== 'notice') return;
        wp_enqueue_style('jqui-css', PM_BASE_URL . 'assets/jqui/theme/jquery-ui.css');
        wp_enqueue_script('jquery-ui-timepicker', PM_BASE_URL . 'assets/js/jquery-ui-timepicker-addon.js', array('jquery', 'jquery-ui-core', 'jquery-ui-datepicker', 'jquery-ui-slider'));

    }

    function adminMenu()
    {
        add_submenu_page("wpdmpm", __('Notice', PM_TEXT_DOMAIN), __('Notice', PM_TEXT_DOMAIN), PM_ADMIN_CAP, 'edit.php?post_type=notice');
    }

    function count()
    {
        $counts = wp_count_posts('notice');
        return $counts->publish;
    }

    function columnsTH($defaults) {
        if(get_post_type() !== 'notice') return $defaults;
        $ui = ['ui' => __('UI', PM_TEXT_DOMAIN)];
        __::array_splice_assoc( $defaults, 1, 0, $ui );
        //$otf['download_count'] = "<span class='wpdm-th-icon ttip' style='font-size: 0.8em'><i  style='font-size: 80%' class='fas fa-arrow-down'></i></span>";
        //$otf['wpdmshortcode'] = 'Short-code';
        //wpdm_array_splice_assoc( $defaults, 3, 0, $otf );
        return $defaults;
    }


    function columnsTD($column_name, $post_ID) {
        if(get_post_type() !== 'notice') return;
        $title = get_the_title($post_ID);
        $t = strtoupper($title[0]);
        $t = $t ? $t : 'A';
        $notice_meta = get_post_meta($post_ID, '__wppm_notice', true);
        if ($column_name == 'ui') {
            ?>
            <div style="padding: 12px;background: <?=__::valueof($notice_meta, 'ui/bgcolor'); ?>;box-shadow: 0 0 5px rgba(0,0,0,0.1);color: <?=__::valueof($notice_meta, 'ui/txtcolor'); ?>;text-align: center;border-radius: 4px"><?= $t ?></div>
            <?php
        }

    }

    function showNotice()
    {
        $notice = new Notice();
        $notices = $notice->getAll();
        if(count($notices) > 0)
            include __DIR__.'/views/show-notice.php';
    }

    function metaBoxes()
    {
        add_meta_box( 'notice-ui', __( 'UI Settings', PM_TEXT_DOMAIN ), [$this, 'noticeStyleOptions'], 'notice', 'side' );
        add_meta_box( 'notice-actions', __( 'Actions', PM_TEXT_DOMAIN ), [$this, 'noticeActions'], 'notice', 'side' );
        add_meta_box( 'notice-activation', __( 'Activation', PM_TEXT_DOMAIN ), [$this, 'noticeActivation'], 'notice', 'side' );
    }

    function noticeStyleOptions($notice)
    {
        $notice_meta = get_post_meta($notice->ID, '__wppm_notice', true);
        include __DIR__.'/views/ui-settings.php';
    }

    function noticeActions($notice)
    {
        $notice_meta = get_post_meta($notice->ID, '__wppm_notice', true);
        include __DIR__.'/views/actions.php';
    }

    function noticeActivation($notice)
    {
        $notice_meta = get_post_meta($notice->ID, '__wppm_notice', true);
        include __DIR__.'/views/activation.php';
    }

    function saveNotice($id, $notice, $update)
    {
        if (wp_is_post_revision($id)) return;
        if (get_post_type($id) !== 'notice' || !isset($_REQUEST['__notice'])) return;
        $__notice = __::query_var('__notice');
        $__notice['reset_key'] = uniqid();
        update_post_meta($id, '__wppm_notice', $__notice);
    }

}
