<?php
if (!defined("ABSPATH")) die();


?>
<style>
    .w3eden .wppm-notice .btn{
        border-radius: 500px;
        padding: 8px 24px;
        margin-top: 12px;
    }
    .w3eden .wppm-notice {
        position: fixed;
        z-index: 999999999;
        background: #ffffff;
        border-radius: 6px;
        box-shadow: 0 0 32px rgba(0, 0, 0, 0.1);
        font-size: 13px;
        font-family: monospace;
        transition: all ease-in-out 400ms;
        line-height: 1.2;
    }

    .w3eden .wppm-notice p:first-child {
        margin-top: 0;
        padding-top: 0;
    }
    .w3eden .wppm-notice p:last-child {
        margin-bottom: 0;
    }

    .w3eden .wppm-notice.hide {
        display: none !important;
    }
    .w3eden .wppm-notice div:empty {
        display: none;
    }
    .w3eden .wppm-notice .btn{
        font-size: 12px;
        padding: 4px 18px !important;;
    }

    <?php foreach ($notices as $n => $notice) { ?>
    .w3eden #wppm-notice-<?=$notice->id; ?>.wppm-notice .btn-notice-action:hover{
        background: rgba(<?= \PrivateMessage\__\__::hex2rgb($notice->noticeActionButtonBackgrond) ?>, 1) !important;
    }
    .w3eden #wppm-notice-<?=$notice->id; ?>.wppm-notice{
        z-index: <?= 9999999999 - $n; ?>;
        width: <?=$notice->width; ?>;
        margin: <?=$notice->margin; ?>px;
        background: <?=$notice->bgColor; ?>;
        color: <?=$notice->txtColor; ?>;
        border-radius: <?=$notice->borderRadius; ?>px;
        font-family: <?=$notice->fontFamily; ?>;
        font-size: <?=$notice->fontSize; ?>px;
        line-height: 1.5;
        overflow: hidden;
    }
    .w3eden #wppm-notice-<?=$notice->id; ?>.wppm-notice p{
        font-size: <?=$notice->fontSize; ?>px !important;
        line-height: 1.5;
    }
    .w3eden #wppm-notice-<?=$notice->id; ?>.wppm-notice .wppm-notice-body {
        padding: <?=$notice->padding; ?>px;
    }
    .w3eden #wppm-notice-<?=$notice->id; ?>.wppm-notice .wppm-notice-footer {
        border-top: 1px solid rgba(0,0,0,0.1);
        padding:<?=$notice->padding/2; ?>px <?=$notice->padding; ?>px !important;
        background: rgba(<?= \PrivateMessage\__\__::hex2rgb($notice->noticeActionButtonBackgrond) ?>, 0.7) !important;
        color: <?= $notice->noticeActionButtonColor ?> !important;
        text-align: center;
        display: block;
        font-weight: bold;
    }
    <?php if($notice->position === 'full_top') { ?>
    .w3eden #wppm-notice-<?=$notice->id; ?>.wppm-notice.full_top{
        margin-bottom: 0 !important;
        top: 0;
        right: 0;
        left: 0;
        width: calc(100% - <?=$notice->margin*2; ?>px) !important;
    }
    <?php } ?>
    <?php if($notice->position === 'centered_bottom') { ?>
    .w3eden #wppm-notice-<?=$notice->id; ?>.wppm-notice.centered_bottom {
        margin-top: 0 !important;
        left: calc(50% - <?= (int)str_replace("px", "", $notice->width)/2; ?>px) !important;
        bottom: 0;
    }
    <?php } ?>
    <?php if($notice->position === 'centered_top') { ?>
    .w3eden #wppm-notice-<?=$notice->id; ?>.wppm-notice.centered_top {
        margin-bottom: 0 !important;
        left: calc(50% - <?= (int)str_replace("px", "", $notice->width)/2; ?>px) !important;
        top: 0;
    }
    <?php } ?>
    <?php if($notice->position === 'full_bottom') { ?>
    .w3eden #wppm-notice-<?=$notice->id; ?>.wppm-notice.full_bottom{
        margin-top: 0 !important;
        bottom: 0;
        right: 0;
        left: 0;
        width: calc(100% - <?=$notice->margin*2; ?>px) !important;
    }
    <?php } ?>
    <?php } ?>
    .w3eden .left_bottom{
        left: 0;
        bottom: 0;
        margin-top: 0 !important;
    }
    .w3eden .wppm-notice.right_bottom{
        margin-top: 0 !important;
        bottom: 0;
        right: 0;
    }
    .w3eden .wppm-notice.left_top{
        margin-bottom: 0 !important;
        top: 0;
        left: 0;
    }
    .w3eden .wppm-notice.right_top{
        margin-bottom: 0 !important;
        top: 0;
        right: 0;
    }

    .w3eden .wppm-notice.modal_window{
        left: 50% !important;
        top: 50% !important;
        transform: translate(-50%, -50%);
        box-shadow: 0 0 0 1000px rgba(0, 0, 0, 0.3);
    }

    .w3eden .wppm-notice .btn-exit-notice{
        display: block;
        opacity: 0;
        position: absolute;
        right: 5px;
        top: 5px;
        text-transform: uppercase;
        padding: 4px 8px !important;
        margin: 0 !important;
        font-size: 9px !important;
        background: rgba(0,0,0,0.4);
        color: #ffffff;
        transition: all ease-in-out 400ms;
        border: 0;
        border-radius: 500px;
    }
    .w3eden .wppm-notice:hover .btn-exit-notice {
        opacity: 1;
    }
    @media (max-width: 800px) {
        .w3eden .wppm-notice .btn-exit-notice{
            display: block !important;
        }
    }

</style>
<div class="w3eden">
    <div id="wppm-notices">
        <div class="wppm-notice" v-bind:class="[{'hide': hideOrNot(notice.id, notice.resetKey)  }, 'wppm-notice', notice.position]" v-for="notice in notices" v-bind:id="'wppm-notice-' + notice.id">
            <div class="wppm-notice-body">
            <button v-if="notice.dismissable" type="button" v-bind:data-dismiss="'#wppm-notice-' + notice.id" class="btn btn-exit-notice" v-on:click="hide(notice.id, notice.resetKey)" v-bind:data-noticeid="notice.id"><?= __('Close', PM_TEXT_DOMAIN); ?></button>
            <span v-html="notice.content"></span>
            </div>
            <a v-if="notice.buttonURL" href="#" class="wppm-notice-footer btn-notice-action" v-on:click="actionButton(notice.buttonURL, notice.id, notice.resetKey, notice.dismissaction)">{{ notice.buttonLabel }}</a>
        </div>
    </div>
    <?php /*foreach ($notices as $notice) { ?>
        <div class="wppm-notice" id="wppm-notice-<?= $notice->id; ?>">
            <button type="button" data-dismiss="#wppm-notice-<?= $notice->id; ?>"
                    class="btn btn-exit-notice btn-xs btn-danger"><?= __('CLOSE', PM_TEXT_DOMAIN); ?></button>
            <?= $notice->content; ?>
        </div>
    <?php }*/ ?>
</div>

<script>
    var _time = ~~(Date.now() / 1000);

    var notice = new Vue({
        el: '#wppm-notices',
        data: {
            notices: <?=json_encode($notices); ?>
        },
        methods: {
            actionButton: function (url, id, resetKey, dismissaction) {
                if(!dismissaction) {
                    localStorage.setItem("__wppm_notice_dismissed_"+resetKey, 1);
                }
                location.href = url;
            },
            hide: function (id, resetKey) {
                this.notices[id].show = false;
                localStorage.setItem("__wppm_notice_dismissed_"+resetKey, 1);
            },
            hideOrNot: function (id, resetKey) {
                return !! ( parseInt(localStorage.getItem("__wppm_notice_dismissed_"+resetKey)) || this.notices[id].show === false );
            }
        }
    })

</script>
