<?php

namespace PrivateMessage\Settings;

use PrivateMessage\Dialogflow\Dialogflow;
use PrivateMessage\Form\Form;

if(!defined("ABSPATH")) die("Shit happens!");


class ChatAutomation extends Section
{

    public $key_file_data;
    public $chat_bot_active;
    public $chat_on_offline;

    function __construct()
    {
        $this->section = 'chatautomation';
        $this->title = __('Chat Automation', PM_TEXT_DOMAIN);
        $this->icon = 'fas fa-robot';
        $this->settings_groups = [
            'ca_keyfile'      => __('Key File', PM_TEXT_DOMAIN),
            'ca_auto'      => __('Automation Settings', PM_TEXT_DOMAIN),
        ];

        $this->settings_fields['__cakeyfile'] = ['group' => 'ca_keyfile', 'validate' => 'html', 'type' => 'custom', 'custom_control' => [new CustomControls(), 'keyFileProcessor'], 'save_callback' => [new CustomControls(), 'saveKeyData'], 'note' => sprintf(__('%s Generate key file %s', PM_TEXT_DOMAIN), "<a target='_blank' href='https://console.cloud.google.com/home/dashboard'>", "</a>"), 'attrs' => [ 'name' => '__cakeyfile', 'id' => '__cakeyfile', 'class' => 'form-control input-lg', 'placeholder' => __("Open the key file, copy content and paste here...", PM_TEXT_DOMAIN), 'value' => ($this->key_file_data = get_option('__cakeyfile', ''))]];
        $this->settings_fields['__caactive'] = ['group' => 'ca_auto', 'type' => 'checkbox', 'attrs' => [ 'name' => '__caactive', 'id' => '__caactive', 'title' => __('Activate Chat Bot', PM_TEXT_DOMAIN), 'class' => 'wppmsg-custom-check', 'value' => 1, 'checked' => ($this->chat_bot_active = (int)get_option('__caactive', 0))]];
        $this->settings_fields['__caofline'] = ['group' => 'ca_auto', 'type' => 'checkbox', 'attrs' => [ 'name' => '__caofline', 'id' => '__caofline', 'title' => __('Reply only when admin is offline', PM_TEXT_DOMAIN), 'class' => 'wppmsg-custom-check', 'value' => 1, 'checked' => ($this->chat_on_offline = (int)get_option('__caofline', 0))]];
        /*
        $this->settings_fields['__pmadminemail'] = ['group' => 'pm_send_settings', 'type' => 'email', 'label' => __('Admin Email to Receive Private Message', PM_TEXT_DOMAIN), 'attrs' => [ 'name' => '__pmadminemail', 'id' => '__pmadminemail', 'class' => 'form-control', 'value' => ($this->pm_admin_email = get_option('__pmadminemail', '')), 'placeholder' => __("Enter a valid email address", PM_TEXT_DOMAIN)]];
        $this->settings_fields['__pmcheckinterval'] = ['group' => 'pm_send_settings', 'type' => 'number', 'label' => __('New Message Check Interval', PM_TEXT_DOMAIN), 'attrs' => [ 'name' => '__pmcheckinterval', 'id' => '__pmcheckinterval', 'class' => 'form-control', 'value' => ($this->pm_check_interval = get_option('__pmcheckinterval', '')), 'placeholder' => __("Seconds", PM_TEXT_DOMAIN)]];
        $this->settings_fields['__pmpage'] = ['group' => 'pm_send_settings', 'type' => 'custom', 'custom_control' => 'wp_dropdown_pages', 'label' => __('Private Message Page', PM_TEXT_DOMAIN), 'attrs' => [ 'name' => '__pmpage', 'id' => '__pmpage', 'class' => 'form-control', 'selected' => ($this->pm_page_id = get_option('__pmpage', '')), 'echo' => 0]];

        $this->settings_fields['__pmlimit'] = ['group' => 'pm_limit', 'type' => 'custom', 'custom_control' => [ new CustomControls(), 'messageLimits'], 'attrs' => [ 'name' => '__pmlimit', 'id' => '__pmlimit', 'class' => 'form-control', 'value' => ($this->pm_limit = get_option('__pmlimit', '')), 'placeholder' => __("Seconds", PM_TEXT_DOMAIN)]];

        $this->settings_fields['__chatactive'] = ['group' => 'chat', 'note' => __('Shows chat bubble on bottom right corner of your site', PM_TEXT_DOMAIN), 'type' => 'checkbox', 'attrs' => [ 'name' => '__chatactive', 'id' => '__chatactive', 'title' => __('Enable live chat box', PM_TEXT_DOMAIN), 'class' => 'wppmsg-custom-check', 'value' => 1, 'checked' => ($this->chat_active = get_option('__chatactive', ''))]];
        $this->settings_fields['__chatboxstyle'] = ['group' => 'chat', 'type' => 'custom', 'custom_control' => [ new CustomControls(), 'chatTemplates'], 'attrs' => [ 'name' => '__chatboxstyle', 'id' => '__chatboxstyle', 'class' => 'form-control', 'selected' => get_option('__chatboxstyle', '')]];
        $this->settings_fields['__chatpage'] = ['group' => 'chat', 'type' => 'custom', 'custom_control' => 'wp_dropdown_pages', 'label' => __('Chat Page', PM_TEXT_DOMAIN), 'note' => __('The page where you have used the shortcode <code>[live_chat]</code>, if you are not using the shortcode, do not select any page', PM_TEXT_DOMAIN), 'attrs' => [ 'name' => '__chatpage', 'id' => '__chatpage', 'class' => 'form-control', 'selected' => ($this->chat_page_id = get_option('__chatpage', '')), 'echo' => 0, 'show_option_none' => 'Not using chat shortcode']];

        $this->settings_fields['__pmjsfix'] = ['group' => 'pm_ui_settings', 'type' => 'checkbox', 'attrs' => [ 'name' => '__pmjsfix', 'id' => '__pmjsfix', 'title' => __('Disable bootstrap.js from frontend', PM_TEXT_DOMAIN), 'class' => 'wppmsg-custom-check', 'value' => 1, 'checked' => get_option('__pmjsfix', '')]];
        $this->settings_fields['__pmcssfix'] = ['group' => 'pm_ui_settings', 'type' => 'checkbox', 'attrs' => [ 'name' => '__pmcssfix', 'id' => '__pmcssfix', 'title' => __('Disable bootstrap.css from frontend', PM_TEXT_DOMAIN), 'class' => 'wppmsg-custom-check', 'value' => 1, 'checked' => get_option('__pmcssfix', '')]];*/

    }
}