<?php

namespace PrivateMessage\Settings;

if (!defined("ABSPATH")) die("Shit happens!");


class Email extends Section
{

    public $logo;
    public $banner;
    public $footer_text;
    public $from_email;
    public $from_name;
    public $chat_mail_to_user;
    public $chat_mail_transcript;
    public $chat_email_msg_template;
    public $chat_email_template;
    public $pm_email_msg_template;
    public $pm_email_template;
    public $pm_signup_email_msg_template;
    public $pm_signup_email_msg_template_admin;
    public $pm_signup_email_template;
    public $pm_password_reset_msg_template;

    function __construct()
    {
        $this->section = 'email';
        $this->title = __('Email', PM_TEXT_DOMAIN);
        $this->icon = 'fa fa-paper-plane';
        $this->settings_groups = ['sender' => __('Email Sender Info', PM_TEXT_DOMAIN),'pm_signup_email' => __('User Signup Confirmation Email', PM_TEXT_DOMAIN),'pm_email' => __('Private Message Email Options', PM_TEXT_DOMAIN), 'pc_email' => __('Private Chat Email Options', PM_TEXT_DOMAIN),'template' => __('Email Template Data', PM_TEXT_DOMAIN)];

        $default_from_email = "noreply@".$_SERVER['HTTP_HOST'];

        $this->settings_fields['__pmfromemail'] = ['group' => 'sender', 'type' => 'email', 'label' => __('From Email', PM_TEXT_DOMAIN), 'attrs' => ['name' => '__pmfromemail', 'id' => '__pmfromemail', 'placeholder' => __('From Email', PM_TEXT_DOMAIN), 'required' => 'required', 'class' => 'form-control', 'value' =>  ($this->from_email = get_option('__pmfromemail', $default_from_email))]];
        $this->settings_fields['__pmfromname'] = ['group' => 'sender', 'type' => 'text', 'label' => __('From Name', PM_TEXT_DOMAIN), 'attrs' => ['name' => '__pmfromname', 'id' => '__pmfromname', 'placeholder' => __('From Name', PM_TEXT_DOMAIN), 'required' => 'required', 'class' => 'form-control', 'value' =>  ($this->from_name = get_option('__pmfromname', get_bloginfo('name')))]];

        $this->settings_fields['__pmsuemailmsgtemplate'] = ['group' => 'pm_signup_email', 'note' => 'Tags: [#first_name#], [#last_name#], [#user_login#], [#user_email#], [#password#], [#sitename#], [#loginurl#], [#homeurl#]', 'validate' => 'html', 'value' => ($this->pm_signup_email_msg_template = get_option('__pmsuemailmsgtemplate', '')), 'type' => 'textarea', 'label' => __('Email message', PM_TEXT_DOMAIN), 'attrs' => ['name' => '__pmsuemailmsgtemplate', 'id' => '__pmsuemailmsgtemplate', 'class' => 'form-control', 'placeholder' => __("Email message", PM_TEXT_DOMAIN), 'style' => 'min-height: 200px;width:100%;']];
        $this->settings_fields['__pmsuaemailmsgtemplate'] = ['group' => 'pm_signup_email', 'note' => 'Tags: [#first_name#], [#last_name#], [#user_login#], [#user_email#], [#password#], [#sitename#], [#loginurl#], [#homeurl#]', 'validate' => 'html', 'value' => ($this->pm_signup_email_msg_template_admin = get_option('__pmsuaemailmsgtemplate', '')), 'type' => 'textarea', 'label' => __('Email message for admin', PM_TEXT_DOMAIN), 'attrs' => ['name' => '__pmsuaemailmsgtemplate', 'id' => '__pmsuaemailmsgtemplate', 'class' => 'form-control', 'placeholder' => __("Email message", PM_TEXT_DOMAIN), 'style' => 'min-height: 200px;width:100%;']];
        $this->settings_fields['__pmpremailmsgtemplate'] = ['group' => 'pm_signup_email', 'note' => 'Tags: [#first_name#], [#last_name#], [#user_login#], [#user_email#], [#reset_password#], [#sitename#], [#loginurl#], [#homeurl#]', 'validate' => 'html', 'value' => ($this->pm_password_reset_msg_template = get_option('__pmpremailmsgtemplate', 'You have requested for your password to be reset.<br/>Please confirm by clicking the button below:  <a href="[#reset_password#]">[#reset_password#]</a><br/>No action required if you did not request it.</b><br/><br/>Best Regards,<br/>Support Team<br/><b><a href="[#homeurl#]">[#sitename#]</a></b>')), 'type' => 'textarea', 'label' => __('Password reset email message for user', PM_TEXT_DOMAIN), 'attrs' => ['name' => '__pmpremailmsgtemplate', 'id' => '__pmpremailmsgtemplate', 'class' => 'form-control', 'placeholder' => __("Email message", PM_TEXT_DOMAIN), 'style' => 'min-height: 200px;width:100%;']];
        $this->settings_fields['__pmsuemailtemplate'] = ['group' => 'pm_signup_email', 'type' => 'custom', 'custom_control' => [new CustomControls(), 'emailTemplates'], 'label' => __('Email template', PM_TEXT_DOMAIN), 'attrs' => ['name' => '__pmsuemailtemplate', 'id' => '__pcemailtemplate', 'class' => 'form-control', 'selected' => ($this->pm_signup_email_template = get_option('__pmsuemailtemplate', 'default.html')), 'placeholder' => __("Email template", PM_TEXT_DOMAIN)]];

        $this->settings_fields['__pcmailtouser'] = ['group' => 'pc_email', 'type' => 'checkbox', 'attrs' => ['name' => '__pcmailtouser', 'id' => '__pcmailtouser', 'title' => __('Send email to offline user when receives a chat reply from admin', PM_TEXT_DOMAIN), 'class' => 'wppmsg-custom-check', 'value' => 1, 'checked' => ($this->chat_mail_to_user = (int)get_option('__pcmailtouser', 0))]];
        $this->settings_fields['__pcmailtranscript'] = ['group' => 'pc_email', 'type' => 'checkbox', 'attrs' => ['name' => '__pcmailtranscript', 'id' => '__pcmailtranscript', 'title' => __('Send chat transcript to user\'s email after chat ended', PM_TEXT_DOMAIN), 'class' => 'wppmsg-custom-check', 'value' => 1, 'checked' => ($this->chat_mail_transcript = (int)get_option('__pcmailtranscript', 0))]];
        $this->settings_fields['__pcemailmsgtemplate'] = ['group' => 'pc_email', 'note' => 'Tags: [#message#] = Message content, [#reply_url#] = Reply url', 'validate' => 'html', 'value' => ($this->chat_email_msg_template = get_option('__pcemailmsgtemplate', '')), 'type' => 'textarea', 'label' => __('Email message', PM_TEXT_DOMAIN), 'attrs' => ['name' => '__pcemailmsgtemplate', 'id' => '__pcemailmsgtemplate', 'class' => 'form-control', 'placeholder' => __("Email message", PM_TEXT_DOMAIN), 'style' => 'min-height: 200px;width:100%;']];
        $this->settings_fields['__pcemailtemplate'] = ['group' => 'pc_email', 'type' => 'custom', 'custom_control' => [new CustomControls(), 'emailTemplates'], 'label' => __('Email template', PM_TEXT_DOMAIN), 'attrs' => ['name' => '__pcemailtemplate', 'id' => '__pcemailtemplate', 'class' => 'form-control', 'selected' => ($this->chat_email_template = get_option('__pcemailtemplate', 'default.html')), 'placeholder' => __("Email template", PM_TEXT_DOMAIN)]];


        //$this->settings_fields['__pmmailtouser'] = ['group' => 'pm_email', 'type' => 'checkbox', 'attrs' => [ 'name' => '__pmmailtouser', 'id' => '__pmmailtouser', 'title' => __('Send email to offline user when receives a chat reply from admin', PM_TEXT_DOMAIN), 'class' => 'wppmsg-custom-check', 'value' => 1, 'checked' => get_option('__pmmailtouser', '')]];
        $this->settings_fields['__pmemailmsgtemplate'] = ['group' => 'pm_email', 'validate' => 'html', 'note' => 'Tags: [#message#] = Message content, [#reply_url#] = Reply url', 'value' => ($this->pm_email_msg_template = get_option('__pmemailmsgtemplate', '')), 'type' => 'textarea', 'label' => __('Email message', PM_TEXT_DOMAIN), 'attrs' => ['name' => '__pmemailmsgtemplate', 'id' => '__pmemailmsgtemplate', 'class' => 'form-control', 'placeholder' => __("Email message", PM_TEXT_DOMAIN), 'style' => 'min-height: 200px;width:100%;']];
        $this->settings_fields['__pmemailtemplate'] = ['group' => 'pm_email', 'type' => 'custom', 'custom_control' => [new CustomControls(), 'emailTemplates'], 'label' => __('Email template', PM_TEXT_DOMAIN), 'attrs' => ['name' => '__pmemailtemplate', 'id' => '__pmemailtemplate', 'class' => 'form-control', 'selected' => ($this->pm_email_template = get_option('__pmemailtemplate', 'default.html')), 'placeholder' => __("Email template", PM_TEXT_DOMAIN)]];

        $this->settings_fields['__pmmaillogo'] = ['group' => 'template', 'type' => 'text', 'label' => __('Logo URL', PM_TEXT_DOMAIN), 'attrs' => ['name' => '__pmmaillogo', 'id' => '__pmmaillogo', 'placeholder' => __('Email Logo URL', PM_TEXT_DOMAIN), 'class' => 'form-control', 'value' =>  ($this->logo = get_option('__pmmaillogo', get_site_icon_url()))]];
        $this->settings_fields['__pmmailbanner'] = ['group' => 'template', 'type' => 'text', 'label' => __('Banner URL', PM_TEXT_DOMAIN), 'attrs' => ['name' => '__pmmailbanner', 'id' => '__pmmailbanner', 'placeholder' => __('Email Banner URL', PM_TEXT_DOMAIN), 'class' => 'form-control', 'value' =>  ($this->banner = get_option('__pmmailbanner', ''))]];
        $this->settings_fields['__pmmailfootertext'] = ['group' => 'template', 'type' => 'text', 'label' => __('Footer Text', PM_TEXT_DOMAIN), 'attrs' => ['name' => '__pmmailfootertext', 'id' => '__pmmailfootertext', 'placeholder' => __('Footer Text', PM_TEXT_DOMAIN), 'class' => 'form-control', 'value' =>  ($this->banner = get_option('__pmmailfootertext', ''))]];

    }

}
