<?php


namespace PrivateMessage\User;

use PrivateMessage\__\__;
use PrivateMessage\__\__Crypt;
use PrivateMessage\__\__Email;
use PrivateMessage\__\__MailUI;
use PrivateMessage\__\__Session;
use PrivateMessage\__\__Template;
use PrivateMessage\Form\Form;

if(!defined("ABSPATH")) die("Shit happens!");

class Profile
{
    private static $instance;

    public static function getInstance()
    {
        if (self::$instance === null) {
            self::$instance = new self;
        }
        return self::$instance;
    }

    private function __construct()
    {
        add_action("init", [$this, 'logout']);
        add_action('init', [$this, 'updateProfile']);
        add_shortcode("wppmsg_edit_profile", [$this, 'editProfile']);
    }

    function editProfile()
    {
        ob_start();
        include __Template::locate("edit-profile.php", __DIR__.'/views');
        return ob_get_clean();
    }

    function logout()
    {
        if(__::query_var('wppmsg_logout') !=='' && wp_verify_nonce(__::query_var('wppmsg_logout'), NONCE_KEY))
        {
            wp_logout();
            wp_safe_redirect(__::query_var('redirect_to'));
            die();
        }
    }

    function updateProfile()
    {
        global $current_user;

        if (isset($_POST['wppmsg_profile']) && is_user_logged_in() && wp_verify_nonce(__::query_var('__wppmsg_epnonce'), NONCE_KEY)) {

            $error = 0;

            $pfile_data['display_name'] = __::sanitize_var($_POST['wppmsg_profile']['display_name']);
            $pfile_data['user_email'] = sanitize_email($_POST['wppmsg_profile']['user_email']);
            $pfile_data['user_email'] = sanitize_email($_POST['wppmsg_profile']['user_email']);


            if ($_POST['password'] != $_POST['cpassword']) {
                __Session::set('member_error', 'Password not matched');
                $error = 1;
            }
            if (!$error) {
                $pfile_data['ID'] = $current_user->ID;
                if ($_POST['password'] != '')
                    $pfile_data['user_pass'] = $_POST['password'];

                wp_update_user($pfile_data);

                update_user_meta($current_user->ID, 'description', __::query_var('wppmsg_profile/description', ['validate' => 'html']));
                update_user_meta($current_user->ID, '__wppmsg_title', __::query_var('wppmsg_profile/title', ['validate' => 'txt']));
                __Session::set('member_success', 'Profile data updated successfully.');
            }

            do_action("wppmsg_update_profile");

            if (__::is_ajax()) {
                if (ob_get_length() > 0) @ob_clean();
                if ($error == 1) {
                    $msg['type'] = 'danger';
                    $msg['title'] = 'ERROR!';
                    $msg['msg'] = __Session::get('member_error');
                    __Session::clear('member_error');
                    wp_send_json($msg);
                    die();
                } else {
                    $msg['type'] = 'success';
                    $msg['title'] = 'DONE!';
                    $msg['msg'] = __Session::get('member_success');
                    __Session::clear('member_success');
                    $msg['data'] = $pfile_data;
                    wp_send_json($msg);
                    die();
                }
            }
            header("location: " . $_SERVER['HTTP_REFERER']);
            die();
        }
    }
}