<?php


namespace PrivateMessage\User;


use PrivateMessage\__\__;
use PrivateMessage\__\__Crypt;
use PrivateMessage\__\__Email;
use PrivateMessage\__\__MailUI;
use PrivateMessage\__\__Session;
use PrivateMessage\Dialogflow\Dialogflow;


class RestAPI
{
    function __construct()
    {
        add_action('rest_api_init', [$this, 'apiInit']);
    }

    function apiInit()
    {


        register_rest_route('wpdmpm/v1', '/user-profile', array(
            'methods' => 'GET',
            'callback' => array($this, 'userProfile'),
            'permission_callback' => '__return_true'
        ));

        register_rest_route('wpdmpm/v1', '/follow-user', array(
            'methods' => 'GET',
            'callback' => array($this, 'followUser'),
            'permission_callback' => '__return_true'
        ));

        register_rest_route('wpdmpm/v1', '/unfollow-user', array(
            'methods' => 'GET',
            'callback' => array($this, 'unfollowUser'),
            'permission_callback' => '__return_true'
        ));

        register_rest_route('wpdmpm/v1', '/add-contact', array(
            'methods' => 'GET',
            'callback' => array($this, 'addContact'),
            'permission_callback' => '__return_true'
        ));

        register_rest_route('wpdmpm/v1', '/remove-contact', array(
            'methods' => 'GET',
            'callback' => array($this, 'removeContact'),
            'permission_callback' => '__return_true'
        ));

        register_rest_route('wpdmpm/v1', '/block-contact', array(
            'methods' => 'GET',
            'callback' => array($this, 'blockContact'),
            'permission_callback' => '__return_true'
        ));

        register_rest_route('wpdmpm/v1', '/unblock-contact', array(
            'methods' => 'GET',
            'callback' => array($this, 'unblockContact'),
            'permission_callback' => '__return_true'
        ));

    }

    function userProfile()
    {
        $userID = __Crypt::decrypt(__::query_var('user'));
        $user = new User($userID);
        return $user;
    }

    function followUser()
    {
        $following = __::query_var('user', 'int');
        $user = new User();
        $success = $user->follow($following);
        return ['success' => $success, 'next_action' => 'unfollow_user', 'label' => __('Unfollow', PM_TEXT_DOMAIN)];
    }

    function unfollowUser()
    {

        $following = __::query_var('user', 'int');

        $user = new User();
        $success = $user->unfollow($following);
        wp_send_json(['success' => $success, 'next_action' => 'follow_user', 'label' => __('Follow', PM_TEXT_DOMAIN)]);
    }

    function addContact()
    {
        $userID = __::query_var('user', 'int');
        $user = new User();
        $success = $user->addToContact($userID);
        return ['success' => $success, 'next_action' => 'remove_contact', 'label' => __('Cancel Whitelist', PM_TEXT_DOMAIN)];
    }

    function removeContact()
    {
        $userID = __::query_var('user', 'int');

        $user = new User();
        $success = $user->removeContact($userID);
        wp_send_json(['success' => $success, 'next_action' => 'add_contact', 'label' => __('Add Whitelist', PM_TEXT_DOMAIN)]);
    }

    function blockContact()
    {
        $userID = __::query_var('user', 'int');
        $user = new User();
        $success = $user->block($userID);
        return ['success' => $success, 'next_action' => 'unblock_contact', 'label' => __('Unblock Contact', PM_TEXT_DOMAIN)];
    }

    function unblockContact()
    {
        $userID = __::query_var('user', 'int');

        $user = new User();
        $success = $user->unblock($userID);
        wp_send_json(['success' => $success, 'next_action' => 'block_contact', 'label' => __('Block Contact', PM_TEXT_DOMAIN)]);
    }

}