<?php

namespace PrivateMessage\__;

class __Template
{
    public $vars;

    function __construct(){
        return $this;
    }

    public static function locate($file, $tpldir = '', $fallback = ''){

        $template_dirs = array(
            get_stylesheet_directory().'/private-message/',
            get_template_directory().'/private-message/',
            ''
        );
        if($tpldir !== '') {
            $template_dirs[] = rtrim($tpldir, '/').'/';
            $template_dirs[] = get_template_directory().'/private-message/'.$tpldir.'/';
        }


        $template_dirs = apply_filters("wppmsg_template_path", $template_dirs);

        foreach ($template_dirs as $template_dir){
            if(file_exists($template_dir.$file))
                return $template_dir.$file;
        }
        return "";
    }

    function assign($var, $val = null){
        if(is_array($var) && is_array($val)){
            foreach ($var as $index => $key){
                $this->vars[$key] = isset($val[$index]) ? $val[$index] : '';
            }
        } else if(is_array($var) && $val === null){
            foreach ($var as $key => $value){
                $this->vars[$key] = $value;
            }
        } else if(is_string($var))
            $this->vars[$var] = $val;
        return $this;
    }

    function fetch($template, $tpldir = '' , $fallback = ''){
        $template = self::locate($template, $tpldir);
        if(is_array($this->vars))
        extract($this->vars);
        ob_start();
        include $template;
        return ob_get_clean();
    }

    function display($template, $tpldir = '' , $fallback = ''){
        echo $this->fetch($template, $tpldir, $fallback);
    }

    function execute($code){
        ob_start();
        if(is_array($this->vars))
            extract($this->vars);
        echo $code;
        return ob_get_clean();
    }

    static function output($data, $vars)
    {
        if(strstr($data, '.php')) {
            $filename = self::locate($data);
            $data = file_get_contents($filename);
        }
        $data = str_replace(array_keys($vars), array_values($vars), $data);
        return $data;
    }

}
