var accessKey = '', secretKey = '';
jQuery(function ($) {
    $.get(ajaxurl+'?action=awsAccess&__s3picker=1', function (res) {
        accessKey = res.access;
        secretKey = res.secret;
    });
    $('#bucketlist').load(ajaxurl+'?action=awsBuckets&__s3picker=1');
    window.localStorage.setItem('current_bucket', '');
    window.localStorage.setItem('current_prefix', '');

    $('body').on('click', '.explore-bucket', function (e) {
        e.preventDefault();
        $('.explore-bucket').removeClass('bselected');
        $(this).addClass('bselected');
        window.localStorage.setItem('current_bucket', $(this).data('bucket'));
        window.localStorage.setItem('current_prefix', '');
        WPDM.blockUI('#s3right');
        $('#contentarea').load(ajaxurl+"?action=exploreBucket&__s3picker=1&region="+$(this).data('region')+"&bucket="+encodeURIComponent($(this).data('bucket')), function () {
            WPDM.unblockUI('#s3right');
        });

    });
    $('body').on('click', '.explore-object', function (e) {
        e.preventDefault();
        WPDM.blockUI('#s3right');
        window.localStorage.setItem('current_bucket', $(this).data('bucket'));
        window.localStorage.setItem('current_prefix', $(this).data('prefix'));
        $('#contentarea').load(ajaxurl+"?action=exploreObject&__s3picker=1&region="+$(this).data('region')+"&bucket="+$(this).data('bucket')+"&prefix="+encodeURIComponent($(this).data('prefix')), function () {
            WPDM.unblockUI('#s3right');
        });

    });

    $('body').on('click', '.attach-file', function (e) {
        e.preventDefault();
        if($(this).hasClass('attached')) return false;
        window.parent.amazons3_attach_file($(this).data('file'));
        $(this).addClass('attached').html("<i class='fa fa-check-double'></i> Attached");

    });

    $('body').on('click', '.delete-file', function (e) {
        e.preventDefault();
        var $this = $(this);
        WPDM.confirm("Are you sure?", "Deleting an item: " + $(this).data('prefix'), [{
         'class': 'btn btn-primary',
            label: 'No, Later',
            callback: function(){
                $(this).modal('hide');
            }
        }, {
            'class': 'btn btn-danger',
            label: 'Yes, Delete',
            callback: function(){
                WPDM.blockUI('#s3right');
                var row = $this.parent('.aactions').parent('.list-group-item');
                $(this).find('.modal-body').html('<i class="fas fa-sun fa-spin"></i> Deleting...');
                $.get(ajaxurl+"?action=deleteFile&__s3picker=1&bucket="+$this.data('bucket')+"&prefix="+encodeURIComponent($this.data('prefix')), function () {
                    WPDM.unblockUI('#s3right');
                    row.hide();
                });
                $(this).modal('hide');
            }
        }]);
    });

    $('#create-bucket').click(function () {
        $('.acthtml').hide();
        $('#cbhtml').show();
        $('#awsModal .panel-title').html('Create Bucket');
        $('#awsModal').slideDown();
        $('#cbmsg').html('');
    });

    $('#create-folder').click(function () {
        $('.acthtml').hide();
        $('#cfhtml').show();
        $('#awsModal .panel-title').html('Create Folder');
        $('#awsModal').slideDown();
        $('#flmsg').html('');
    });

    $('#upload-file').click(function () {
        $('.acthtml').hide();
        $('#ufhtml').show();
        $('#awsModal .panel-title').html('Upload File');
        $('#awsModal').slideDown();
        $('#ufmsg').html('');
    });


    $('#cbbtn').on('click', function () {
        var bucketname = $('#bktname').val();
        $('#cbmsg').html('<i class="fa fa-spinner fa-spin"></i> Please Wait...');
        $.post(ajaxurl, {__s3picker: 1, bucketname: bucketname, action: 'CreateBucket'}, function (res) {
            if(res == 'Done!') {
                res = 'Created Successfully! Refreshing Bucket List...';
                $('#cbmsg').html(res);
                $('#bucketlist').load(ajaxurl+'?action=awsBuckets&__s3picker=1', function () {
                    $('#awsModal').modal('hide');
                    $('#cbmsg').html('');
                });
            }
            $('#cbmsg').html(res);
        });
    });


    $('#flbtn').on('click', function () {

        $('#flmsg').html('<i class="fa fa-spinner fa-spin"></i> Please Wait...');
        var foldername = $('#fldname').val();
        var bucketname = window.localStorage.getItem('current_bucket') || '';
        var prefix = window.localStorage.getItem('current_prefix') || '';

        if(bucketname == ''){
            $('#flmsg').html('Select a bucket first from bucket menu').show();
            return false;
        }
        $('#cbmsg').html('<i class="fa fa-spinner fa-spin"></i> Please Wait...');
        $.post(ajaxurl, {__s3picker: 1, bucket: bucketname,prefix: prefix,folder: foldername, action: 'createObject'}, function (res) {
            if(res == 'Done!') {
                res = 'Created Successfully! Refreshing Folder List...';
                $('#flmsg').html(res);
                if(prefix != '')
                    var command = ajaxurl+"?action=exploreObject&__s3picker=1&bucket="+bucketname+"&prefix="+encodeURIComponent(prefix);
                else
                    var command = ajaxurl+"?action=exploreBucket&__s3picker=1&bucket="+bucketname;
                $('#contentarea').load(command, function () {
                    $('#awsModal').modal('hide');
                    $('#flmsg').html('');
                });
            }
            $('#cbmsg').html(res);
        });
    });

    $('#uploadform').submit(function (e) {
        e.preventDefault();
        AWS.config.update({
            accessKeyId : accessKey,
            secretAccessKey : secretKey
        });

        //AWS.config.region = 'us-standard';

        var bucketname = window.localStorage.getItem('current_bucket') || '';
        var prefix = window.localStorage.getItem('current_prefix') || '';

        if(bucketname == ''){
            $('#ufmsg').html("<span class='text-danger'><i class='fa fa-warning'></i> Select a bucket first from bucket menu").show();
            return false;
        }

        var bucket = new AWS.S3({params: {Bucket: bucketname}});

        var fileChooser = document.getElementById('ufile');
        var file = fileChooser.files[0];
        console.log(file);

        if (file) {
            var params = {Key: file.name, ContentType: file.type, Body: file};
            bucket.upload(params).on('httpUploadProgress', function(evt) {
                $('#ufmsg').html("<span class='text-info'><i class='fa fa-spinner fa-spin'></i> Uploaded :: " + parseInt((evt.loaded * 100) / evt.total)+'%</span>');
            }).send(function(err, data) {
                $('#ufmsg').html("<span class='text-success'><i class='fa fa-check-circle'></i> Completed Successfully. Refreshing...</span>");
                if(prefix != '')
                    var command = ajaxurl+"?action=exploreObject&bucket="+bucketname+"&prefix="+prefix;
                else
                    var command = ajaxurl+"?action=exploreBucket&bucket="+bucketname;
                $('#contentarea').load(command, function () {
                    $('#awsModal').modal('hide');
                    $('#ufmsg').html('');
                });
            });
        } else{
            $('#ufmsg').html("<span class='text-danger'><i class='fa fa-warning'></i> No file selected</span>");
        }
        return false;

    });

    $('.btn-file :file').on('fileselect', function(event, numFiles, label) {

        var input = $(this).parents('.input-group').find(':text'),
            log = numFiles > 1 ? numFiles + ' files selected' : label;

        if( input.length ) {
            input.val(log);
        } else {
            if( log ) alert(log);
        }

    });

    $(document).on('change', '.btn-file :file', function() {
        var input = $(this),
            numFiles = input.get(0).files ? input.get(0).files.length : 1,
            label = input.val().replace(/\\/g, '/').replace(/.*\//, '');
        input.trigger('fileselect', [numFiles, label]);
    });

});




