<?php if(!defined('ABSPATH')) die('!');

global $current_user;
$selected_buckets = get_option('__wpdm_s3_bucket');
$selected_bucket = wpdm_valueof($selected_buckets, $current_user->roles[0]);

$wpdm_s3_readonly = get_option('__wpdm_s3_readonly');
$wpdm_s3_readonly = wpdm_valueof($wpdm_s3_readonly, $current_user->roles[0], ['validate' => 'int']);

?>
<script src="https://sdk.amazonaws.com/js/aws-sdk-2.3.11.min.js"></script>
<script src="<?php echo WPDM_AWS_URL; ?>app/controllers.js"></script>
<div class="w3eden">

    <div class="panel panel-default" id="wpdm-wrapper-panel">
        <div class="panel-heading"><span class="pull-right" id="ngloading"><i class="fa fa-refresh fa-spin"></i> &nbsp; Loading...</span>
            <?php if(!$wpdm_s3_readonly) { ?>
            <div class="pull-right">
                <?php if(!$selected_bucket){ ?>
                <button type="button" class="btn btn-sm btn-primary" id="create-bucket"><i class="fab fa-dropbox"></i> &nbsp;Create Bucket</button>
                <?php } ?>
                <button type="button" class="btn btn-sm btn-info" id="create-folder"><i class="fa fa-folder"></i> &nbsp;Create Dir</button>
                <button type="button" class="btn btn-sm btn-success" id="upload-file"><i class="fa fa-upload"></i> &nbsp;Upload File</button>
            </div>
            <?php } ?>
            <b><i class="fab fa-aws"></i> &nbsp; Amazon S3 Manager <sup>&beta;</sup></b></div>
        <div class="panel-body">

            <div id="explorer" style="margin-top: 60px">
                <?php if(!$selected_bucket){ ?>
                <div class="col-md-3">
                    <div class="panel panel-default">
                        <div class="panel-heading"><b>Explore Buckets</b></div>
                        <ul class="list-group" id="bucketlist">
                            <li class="list-group-item"><i class="fas fa-sun fa-spin"></i> Loading Bucket...</li>
                        </ul>
                    </div>

                </div>
                <?php } ?>
                <div class="col-md-<?php echo $selected_bucket ? 12: 9  ?>">
                    <div id="contentarea">
                        <div id="placeholder">
                            <?php if($selected_bucket) { ?>
                                <i class="fa fa-sun fa-spin"></i> Loading items...
                            <?php } else { ?>
                            Select Bucket From Left to Explore
                            <?php } ?>
                        </div>
                    </div>
                </div>




            </div>
        </div>
    </div>

    <div style="display: none;margin: 15px 15px 15px 0px; position: fixed; z-index: 999999; right: 20px; bottom: 0px;" tabindex="-1" id="awsModal">
        <div class="panel panel-default" style="box-shadow: 0 0 40px rgba(0,0,0,0.2) !important;">
            <div class="panel-heading">
                <button onclick="jQuery('#awsModal').slideUp();" class="btn btn-link text-white btn-xs pull-right p-0" style="padding: 0;margin-top: 3px;"><i class="fa fa-times-circle text-danger"></i></button>
                <strong class="panel-title">Create Bucket</strong>
            </div>
            <div class="panel-body">
                <div id="cbhtml" class="acthtml">
                    <div class="input-group">
                        <input id="bktname" type="text" class="form-control" placeholder="Bucket Name"><span class="input-group-btn"><button id="cbbtn" type="button" class="btn btn-default">Create</button></span>
                    </div>
                    <div id="cbmsg" style="margin-top: 10px"></div>
                </div>
                <div id="cfhtml" class="acthtml">
                    <div class="input-group">
                        <input id="fldname" type="text" class="form-control" placeholder="Folder Name"><span class="input-group-btn"><button id="flbtn" type="button" class="btn btn-default">Create</button></span>
                    </div>
                    <div id="flmsg" style="margin-top: 10px"></div>
                </div>
                <div id="ufhtml" class="acthtml">
                    <form id="uploadform" method="post" enctype="multipart/form-data">
                        <style>
                            div#s3dropzone{
                                width: 300px;
                                max-width: 100%;
                                padding: 60px;border: 2px dashed #4343d4;margin-top: 15px;
                                text-align: center;
                                border-radius: 3px;
                                font-size: 13px;
                                color: var(--color-muted);
                                cursor: pointer;
                                font-family: 'Overpass Mono', monospace;
                                margin: 0;
                            }
                            div#s3dropzone input{
                                opacity: 0;
                            }
                            div#s3dropzone.hover{
                                border: 2px solid #7b7bff;
                            }
                        </style>

                        <div id="s3dropzone">
                            <?php _e("Drop file here or<br/>Click to open chooser", "wpdm-amazon-s3") ?>
                        </div>


                    </form>
                    <div id="ufmsg" style="margin-top: 10px"></div>
                </div>
            </div>

        </div>
    </div>

</div>
<script>
    jQuery(function ($){
        <?php if($selected_bucket) { ?>
        WPDM.blockUI('#s3right');
        $('#contentarea').load(ajaxurl+"?action=exploreBucket&__s3picker=1", function () {
            WPDM.unblockUI('#s3right');
        });
        <?php } ?>
    });
</script>

<script>
    var ajaxurl = "<?php echo admin_url('admin-ajax.php'); ?>";

    document.getElementById('s3dropzone').addEventListener("dragover", __dragOver, false)
    document.getElementById('s3dropzone').addEventListener("dragleave", __dragOver, false)
    document.getElementById('s3dropzone').addEventListener("drop", __dropHandler, false);

    function __dragOver(e){
        e.stopPropagation();
        e.preventDefault();
        e.target.className = (e.type == "dragover" ? "hover" : "");
    }
    function __dropHandler(ev) {
        ev.preventDefault();
        ev.stopPropagation();
        var files = ev.target.files || ev.dataTransfer.files;

        AWS.config.update({
            accessKeyId : accessKey,
            secretAccessKey : secretKey
        });
        var bucketname = window.localStorage.getItem('current_bucket') || '';
        var prefix = window.localStorage.getItem('current_prefix') || '';
        var bucket = new AWS.S3({params: {Bucket: bucketname}});
        for (var i = 0, file; file = files[i]; i++) {
            __uploadFile(file, bucket, bucketname, prefix);
        }
    }

    function __uploadFile(file, bucket, bucketname, prefix) {
        var $ = jQuery;
        var folder = '';
        if(prefix !== undefined && prefix !== '') folder = prefix + '/';
        var params = {Key: folder + file.name, ContentType: file.type, Body: file};
        console.log(params);
        bucket.upload(params).on('httpUploadProgress', function(evt) {
            $('#ufmsg').html("<span class='text-info'><i class='fa fa-spinner fa-spin'></i> Uploaded :: " + parseInt((evt.loaded * 100) / evt.total)+'%</span>');
        }).send(function(err, data) {
            $('#ufmsg').html("<span class='text-success'><i class='fa fa-check-circle'></i> Completed Successfully. Refreshing...</span>");

            if(prefix != '' || prefix !== undefined)
                var command = ajaxurl+"?action=exploreObject&bucket="+bucketname+"&prefix="+encodeURI(prefix);
            else
                var command = ajaxurl+"?action=exploreBucket&bucket="+bucketname;
            $('#contentarea').load(command, function () {
                $('#awsModal').slideUp();
                $('#ufmsg').html('');
            });
        });

    }

    function __selectFile() {
        var input = document.createElement('input');
        input.type = 'file';

        input.onchange = e => {

            var files = e.target.files || e.dataTransfer.files;
            AWS.config.update({
                accessKeyId : accessKey,
                secretAccessKey : secretKey
            });
            var bucketname = window.localStorage.getItem('current_bucket') || '';
            var prefix = window.localStorage.getItem('current_prefix') || '';
            var bucket = new AWS.S3({params: {Bucket: bucketname}});
            for (var i = 0, file; file = files[i]; i++) {
                __uploadFile(file, bucket, bucketname, prefix);
            }

        }

        input.click();
    }


    jQuery(function ($) {

        $('a').each(function () {
            $(this).attr('target', '_blank');
        });

        $('body').on('click','a', function () {
            $(this).attr('target', '_blank');
        });

        $('div#s3dropzone').on('click', function (){
            __selectFile();
        });

        <?php if($selected_bucket) { ?>
        WPDM.blockUI('#s3right');
        $('#contentarea').load(ajaxurl+"?action=exploreBucket&__s3picker=1", function () {
            WPDM.unblockUI('#s3right');
        });
        <?php } ?>

        $('#aws-file-picker').on('hidden.bs.modal', function (e) {
            var parentWindow = document.createElement("a");
            parentWindow.href = document.referrer.toString();
            if(parentWindow.hostname === window.location.hostname)
                window.parent.wpdm_iframe_modal('close');
            else
                window.parent.postMessage({'task': 'hideiframe'}, "*");
        });

        $(window).on('resize', function () {
            $('#aws-file-picker .modal-content').css('height', (window.innerHeight - 200) + 'px');
            $('#aws-file-picker [ss-container]').css('height', (window.innerHeight - 345) + 'px');
        });

        showModal();
    });

    function showModal() {
        jQuery('#aws-file-picker').modal('show');
        jQuery('#aws-file-picker .modal-content').css('height', (window.innerHeight - 200) + 'px');
        jQuery('#aws-file-picker [ss-container]').css('height', (window.innerHeight - 345) + 'px');
    }

</script>

<style>
    .w3eden .alert.alert-info::before,
    .w3eden *{
        border-radius: 0 !important;
    }
    .aactions{
        margin-top: -2px;
        font-size: 11px;
    }
    .aactions a{
        margin-left: 8px;
    }
    #ngloading{
        font-weight: bold; color: white; position: absolute; z-index: 999999; right: 5px; padding: 7px 12px; margin-top: -3px; background: rgba(228, 75, 75, 0.9) none repeat scroll 0% 0%;display: none;
    }
    a:focus,
    a:hover{
        text-decoration: none !important;
        outline: none !important;
    }
    .w3eden .list-group-item.active, .w3eden .list-group-item.active:hover, .w3eden .list-group-item.active:focus{
        background: #2BA1D7 !important;
        background-image: none !important;
        border-color: #2BA1D7 !important;
    }
    .w3eden .text-primary {
        color: #2eabed;
    }
    .w3eden a.text-primary:hover,
    .w3eden a.text-primary:focus {
        color: #178acc;
    }
    .w3eden .text-success {
        color: #3aa76d;
    }
    .w3eden a.text-success:hover,
    .w3eden a.text-success:focus {
        color: #1a944a;
    }
    .w3eden .text-info {
        color: #b680cd;
    }
    .w3eden a.text-info:hover,
    .w3eden a.text-info:focus {
        color: #976aaa;
    }
    .w3eden .text-warning {
        color: #c09853;
    }
    .w3eden a.text-warning:hover,
    .w3eden a.text-warning:focus {
        color: #a47e3c;
    }
    .w3eden .text-danger {
        color: #db5855;
    }
    .w3eden a.text-danger:hover,
    .w3eden a.text-danger:focus {
        color: #953b39;
    }
    .w3eden .list-group-item{
        border-color: #eeeeee;
    }
    .w3eden .modal-dialog {
        padding-top: 100px;
    }
    .w3eden .breadcrumb{
        border-radius: 0;
        box-shadow: 0 1px 2px rgba(0, 0, 0, 0.1);
        background: #ffffff;
    }
    .w3eden .list-group-item:last-child{
        border-bottom: 0;
    }
    .w3eden .modal.fade.in{
        z-index: 99999 !important;
    }
    .btn-file {
        position: relative;
        overflow: hidden;
    }
    .btn-file input[type=file] {
        position: absolute;
        top: 0;
        right: 0;
        min-width: 100%;
        min-height: 100%;
        font-size: 100px;
        text-align: right;
        filter: alpha(opacity=0);
        opacity: 0;
        background: red;
        cursor: inherit;
        display: block;
    }
    input[readonly] {
        background-color: white !important;
        cursor: text !important;
    }
    .bselected{
        font-weight: 900;
        color: #2a9cd7;
    }
    .bselected:after{
        content: "►";

        position: absolute;
        right: 10px;
        color: #2eabed;
    }


    #placeholder{
        padding: 200px 0;
        text-align: center;
        font-size: 16pt;
        color: #dddddd;
        background: #ffffff;
        box-shadow: 0 1px 2px rgba(0,0,0,0.1);
    }
    .attach-file{
        display: none;
    }
</style>
