<?php
/**
 * Base: wpdmpro
 * Developer: shahjada
 * Team: W3 Eden
 * Date: 31/5/20 15:44
 */
if(!defined("ABSPATH")) die();

$key = WPDM_AmazonS3::getS3Cred();

?>
<div class="panel panel-default">
    <div class="panel-heading"><?php _e( "Amazon S3 Settings", "wpdm-amazon-s3" ) ?></div>
    <div class="panel-body-table">
        <table class="table table-striped" style="margin: 0">
            <thead>
            <tr>
                <th width="28%"><?php _e( "Access Key", "wpdm-amazon-s3" ) ?></th>
                <th><?php _e( "Secret Key", "wpdm-amazon-s3" ) ?></th>
                <th style="width: 120px"><?php _e( "Note", "wpdm-amazon-s3" ) ?></th>
                <th style="width: 40px;text-align: center"><i class="fas fa-check-double"></i></th>
                <th style="width: 40px;text-align: center"><i class="fas fa-trash"></i></th>
            </tr>
            </thead>
            <tbody id="s3info">
            <?php
            $_wpdm_aws_keys = get_option('_wpdm_aws_key');
            $__wpdm_aws_selected_keys = get_option('__wpdm_aws_selected_keys');
            if(!$_wpdm_aws_keys) {
                $__wpdm_aws_selected_keys = round(microtime(true) * 1000);
                $_wpdm_aws_keys = array($__wpdm_aws_selected_keys => array('access' => get_option('_wpdm_aws_access_key'), 'secret' => get_option('_wpdm_aws_secret_key'), 'note' => 'Default'));
            }
            if(!isset($_wpdm_aws_keys[$__wpdm_aws_selected_keys])){
                $keys = array_keys($_wpdm_aws_keys);
                $__wpdm_aws_selected_keys = $keys[0];
            }

            foreach ($_wpdm_aws_keys as $index => $key){
                ?>

                <tr id="row_<?php echo $index; ?>">
                    <td><input class="form-control input-sm" type="text" name="_wpdm_aws_key[<?php echo $index; ?>][access]" value="<?php echo $key['access']; ?>" /> </td>
                    <td><input class="form-control input-sm"  type="text" name="_wpdm_aws_key[<?php echo $index; ?>][secret]" value="<?php echo $key['secret']; ?>" /></td>
                    <td><input class="form-control input-sm"  type="text" name="_wpdm_aws_key[<?php echo $index; ?>][note]" value="<?php echo $key['note']; ?>" /></td>
                    <td><input name="__wpdm_aws_selected_keys" value="<?php echo $index; ?>" <?php checked($index, $__wpdm_aws_selected_keys); ?> type="radio" /></td>
                    <td><a href="#" data-row="#row_<?php echo $index; ?>"  onclick="return removeS3Info(this)" class="btn del-s3info btn-danger btn-sm"><i class="fas fa-trash"></i></a></td>
                </tr>

            <?php } ?>


            </tbody>
            <tfoot style="background: #eeeeee">
            <tr>
                <td><input class="form-control input-sm" type="text" id="adds3ak" name="" value="" /> </td>
                <td><input class="form-control input-sm"  type="text" id="adds3sk" name="" value="" /></td>
                <td><input class="form-control input-sm"  type="text" id="adds3nt" name="" value="" /></td>
                <td><input disabled="disabled" type="radio" /></td>
                <td><a href="#" id="adds3info" class="btn btn-success btn-sm"><i class="fas fa-plus-circle"></i></a></td>
            </tr>
            </tfoot>
        </table>
        <input type="hidden" name="_wpdm_aws_bucket"  value="<?php echo get_option('_wpdm_aws_bucket',uniqid()); ?>" />

    </div>

</div>
<div class="panel panel-default" id="wpdm-bac">
    <div class="panel-heading"><?php _e( "Amazon S3 Bucket Access Control", "wpdm-amazon-s3" ) ?></div>
    <div class="panel-body-table">
        <table class="table table-striped" style="margin: 0">
            <thead>
            <tr>
                <th width="30%"><?php _e('Role', 'wpdm-amazon-s3'); ?></th>
                <th><?php _e('Bucket', 'wpdm-amazon-s3'); ?></th>
                <th class="text-right"><label><?php _e('ReadOnly?', 'wpdm-amazon-s3'); ?> <input type="checkbox" id="s3readonly" /></label></th>
            </tr>
            </thead>
            <tbody>
            <?php
            global $wp_roles;
            $roles = array_reverse($wp_roles->role_names);
            $selected_buckets = get_option('__wpdm_s3_bucket');

            $wpdm_s3_readonly = get_option('__wpdm_s3_readonly');

            foreach ($roles as $role => $name){ ?>
            <tr>
                <td><?= $name; ?></td>
                <td><select name="__wpdm_s3_bucket[<?= $role; ?>]" data-selected="<?= wpdm_valueof($selected_buckets, $role); ?>" style="width: 100%" class="form-control wpdm-custom-select wpdm-bucket-access"><option>Loading...</option></select></td>
                <td class="text-right"><input name="__wpdm_s3_readonly[<?= $role; ?>]" <?php checked(1, (int)wpdm_valueof($wpdm_s3_readonly, $role)); ?> value="1" type="checkbox" class="wpdm-custom-check s3readonly"></td>
            </tr>
            <?php } ?>
            </tbody>
        </table>
    </div>
</div>
<div class="panel panel-default" id="wpdm-bac">
    <div class="panel-heading"><?php _e( "Amazon S3 Direct Upload", "wpdm-amazon-s3" ) ?></div>
    <div class="panel-body">
        <div class="form-group">
            <input type="hidden" name="__wpdm_s3_direct_dropzone" value="0">
            <label><input type="checkbox" value="1" name="__wpdm_s3_direct_dropzone" <?php checked(1, get_option('__wpdm_s3_direct_dropzone')) ?>> <?php _e( "Auto Upload All Files To S3", "wpdm-amazon-s3" ) ?></label><br/>
            <em class="note"><?php _e( "All uploaded files will be stored in the specified bucket/folder of Amazon S3", "wpdm-amazon-s3" ) ?></em>
        </div>
        <div class="form-group" id="ddzone">
            <label><?php _e( "Select Upload Destination", "wpdm-amazon-s3" ) ?></label>
            <div class="row">
                <div class="col-md-6">
                    <select id="ddzbucket" title="<?php _e( "Select Bucket", "wpdm-amazon-s3" ) ?>" name="__wpdm_s3_ddz_bucket" style="width: 100%">
                        <option>Loading...</option>
                    </select>
                </div>
                <div class="col-md-6">
                    <select id="ddzfolder" title="<?php _e( "Select Folder", "wpdm-amazon-s3" ) ?>" name="__wpdm_s3_ddz_folder" style="width: 100%">

                    </select>
                </div>
            </div>
        </div>
    </div>
    <div class="panel-footer" style="border-radius: 0;border-top: 1px solid #eee">
        <input type="hidden" name="__wpdm_s3_packagedir" value="0">
        <label><input type="checkbox" name="__wpdm_s3_packagedir" value="1" <?php checked(1, get_option('__wpdm_s3_packagedir', 0)); ?>> <?php _e( "Keep files of each package in a separate folder", "wpdm-amazon-s3" ) ?></label>
    </div>

    <div class="panel-heading" style="border-radius: 0;border-top: 1px solid #eee">
        <input type="hidden" name="__wpdm_s3_autosync" value="0">
        <label><input type="checkbox" name="__wpdm_s3_autosync" value="1" <?php checked(1, get_option('__wpdm_s3_autosync', 0)); ?>> <?php _e( "Auto-Sync Local Files Attached With Packages", "wpdm-amazon-s3" ) ?></label>
    </div>
    <div class="panel-body" id="sync-footer" style="border-radius: 0;">
        <div class="row">
            <div class="col-md-6">
                <select id="syncbucket" title="<?php _e( "Select Bucket", "wpdm-amazon-s3" ) ?>" name="__wpdm_s3_autosync_bucket" style="width: 100%">
                    <option>Loading...</option>
                </select>
            </div>
            <div class="col-md-6">
                <select id="syncfolder" title="<?php _e( "Select Folder", "wpdm-amazon-s3" ) ?>" name="__wpdm_s3_autosync_folder" style="width: 100%">

                </select>
            </div>
        </div>
    </div>
    <div class="panel-footer">
        <input type="hidden" name="__wpdm_s3_filedelete" value="0">
        <label><input type="checkbox" name="__wpdm_s3_filedelete" value="1" <?php checked(1, get_option('__wpdm_s3_filedelete', 0)); ?>> <?php _e( "Delete attached files from amazon s3 when a package is deleted", "wpdm-amazon-s3" ) ?></label>
    </div>
</div>
<script>
    jQuery(function ($) {

        $('#s3readonly').on('click', function (){
            $('.s3readonly').attr('checked', $(this).is(':checked'));
        });

        $('#adds3info').on('click', function () {
            var index = $.now();
            if($('#adds3ak').val() =='') return false;
            $('#s3info').append('<tr>\n' +
                '                                <td><input class="form-control input-sm" type="text" name="_wpdm_aws_key[' + index + '][access]" value="' + $('#adds3ak').val() + '" /></td>\n' +
                '                                <td><input class="form-control input-sm" type="text" name="_wpdm_aws_key[' + index + '][secret]" value="' + $('#adds3sk').val() + '" /></td>\n' +
                '                                <td><input class="form-control input-sm" type="text" name="_wpdm_aws_key[' + index + '][note]" value="' + $('#adds3nt').val() + '" /></td>\n' +
                '                                <td><input name="__wpdm_aws_selected_keys" value="'+index+'" type="radio" /></td>\n' +
                '                                <td><a href="#" onclick="return removeS3Info(this)" class="btn btn-danger btn-sm"><i class="fas fa-trash"></i></a></td>\n' +
                '                            </tr>');
            $('#adds3ak').val('');
            $('#adds3sk').val('');
            return false;

        });

        $('#syncbucket').on('change', function () {
            getFolders($(this).val());
        });
        $('#ddzbucket').on('change', function () {
            getDDZFolders($(this).val());
        });
        WPDM.blockUI('#sync-footer');
        WPDM.blockUI('#ddzone');
        WPDM.blockUI('#wpdm-bac');
        $.get(ajaxurl, { action: 'awsBuckets', datatype: 'json' }, function (response) {
            $('#syncbucket, #ddzbucket').html(new Option('Select Bucket', ''));
            $('.wpdm-bucket-access').html(new Option('All Buckets', ''));
            $.each(response.buckets, function (key, bucket) {
                $('.wpdm-bucket-access').each(function (){
                    if($(this).data('selected') === bucket)
                        $(this).append(new Option(bucket, bucket, true, true));
                    else
                        $(this).append(new Option(bucket, bucket));
                });
                //$('.wpdm-bucket-access').append(new Option(bucket, bucket));
                if('<?php echo get_option('__wpdm_s3_autosync_bucket', '') ?>' === bucket)
                    $('#syncbucket').append(new Option(bucket, bucket, true, true));
                else
                    $('#syncbucket').append(new Option(bucket, bucket));

                if('<?php echo get_option('__wpdm_s3_ddz_bucket', '') ?>' === bucket)
                    $('#ddzbucket').append(new Option(bucket, bucket, true, true));
                else
                    $('#ddzbucket').append(new Option(bucket, bucket));
            });

            $('#syncbucket, #ddzbucket, .wpdm-bucket-access').trigger("chosen:updated");
            if('<?php echo get_option('__wpdm_s3_autosync_bucket', '') ?>' !== '')
                getFolders('<?php echo get_option('__wpdm_s3_autosync_bucket') ?>');
            else
                WPDM.unblockUI('#sync-footer');
            if('<?php echo get_option('__wpdm_s3_ddz_bucket', '') ?>' !== '')
                getDDZFolders('<?php echo get_option('__wpdm_s3_ddz_bucket') ?>');
            else
                WPDM.unblockUI('#ddzone');
            WPDM.unblockUI('#wpdm-bac');
        });



        $.getScript('https://sdk.amazonaws.com/js/aws-sdk-2.685.0.min.js', function () {
            AWS.config.update({
                accessKeyId : '<?php echo $key['access']; ?>',
                secretAccessKey : '<?php echo $key['secret']; ?>'
            });
        });


    });

    function getFolders(bucket){
        jQuery('#syncfolder').html(new Option('Loading Folders...', '-'));
        jQuery('#syncfolder').trigger("chosen:updated");
        jQuery.get(ajaxurl, { action: 'exploreBucket', datatype: 'json', bucket: bucket }, function (response) {
            jQuery('#syncfolder').html(new Option('Select Folder or Keep in Bucket', ''));
            jQuery.each(response.folders, function (key, folder) {
                if('<?php echo get_option('__wpdm_s3_autosync_folder', '') ?>' === folder)
                    jQuery('#syncfolder').append(new Option(folder, folder, true, true));
                else
                    jQuery('#syncfolder').append(new Option(folder, folder));
            });
            jQuery('#syncfolder').trigger("chosen:updated");
            WPDM.unblockUI('#sync-footer');
        });
    }

    function getDDZFolders(bucket){
        jQuery('#ddzfolder').html(new Option('Loading Folders...', '-'));
        jQuery('#ddzfolder').trigger("chosen:updated");
        jQuery.get(ajaxurl, { action: 'exploreBucket', datatype: 'json', bucket: bucket }, function (response) {
            jQuery('#ddzfolder').html(new Option('Select Folder or Keep in Bucket', ''));
            jQuery.each(response.folders, function (key, folder) {
                if('<?php echo get_option('__wpdm_s3_ddz_folder', '') ?>' === folder)
                    jQuery('#ddzfolder').append(new Option(folder, folder, true, true));
                else
                    jQuery('#ddzfolder').append(new Option(folder, folder));
            });
            jQuery('#ddzfolder').trigger("chosen:updated");
            WPDM.unblockUI('#ddzone');
        });
    }

    function removeS3Info(o) {
        if(!confirm('Are you sure?')) return false;
        jQuery(jQuery(o).data('row')).remove();
        return false;
    }
</script>
