<?php
/**
 * User: shahnuralam
 * Date: 9/17/17
 * Time: 2:14 AM
 */
if(!defined('ABSPATH')) die();
$pdf = isset($_GET['__wpdm_pdf_viewer'])?esc_attr($_GET['__wpdm_pdf_viewer']):'';
$_GET['file'] = $pdf;
?>
<!DOCTYPE html>

<html dir="ltr" mozdisallowselectionprint moznomarginboxes>
<head>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1, maximum-scale=1">
    <meta name="google" content="notranslate">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <title>PDF Viewer</title>


    <link rel="stylesheet" href="<?php echo plugins_url('wpdm-pdf-viewer/assets/css/viewer.css'); ?>">
    <link rel="stylesheet" href="<?php echo WPDM_BASE_URL; ?>assets/bootstrap3/css/bootstrap.css">
    <link rel="stylesheet" href="<?php echo WPDM_BASE_URL; ?>assets/css/front3.css">


    <script src="<?php echo plugins_url('wpdm-pdf-viewer/assets/pdfjs/pdf.js'); ?>"></script>


    <script src="<?php echo plugins_url('wpdm-pdf-viewer/assets/js/viewer.js'); ?>"></script>
<style>
    #the-canvas{
        max-width: 100%;
        height: auto;
    }
</style>
    <?php
    \WPDM\__\Apply::uiColors();
    ?>
</head>

<body tabindex="1" class="loadingInProgress w3eden">
<div style="padding: 5px;background: #eeeeee;position: fixed;width: 100%;top: 0;">
    <div class="btn-group">
    <button id="prev" class="btn btn-xs btn-info">Previous</button>
    <button id="next" class="btn btn-xs btn-info">Next</button>
    </div>
    <span class="btn btn-xs btn-default pull-right" disabled="disabled">Page: <span id="page_num"></span> / <span id="page_count"></span></span>
</div>
<table class="table">
    <tr><td align="center">

<canvas id="the-canvas"></canvas>

        </td></tr>
</table>
            <script>
    // If absolute URL from the remote server is provided, configure the CORS
    // header on that server.
    var url = '<?php echo $pdf; ?>';

    // The workerSrc property shall be specified.
    PDFJS.workerSrc = '//mozilla.github.io/pdf.js/build/pdf.worker.js';

    var pdfDoc = null,
        pageNum = 1,
        pageRendering = false,
        pageNumPending = null,
        scale = 1,
        canvas = document.getElementById('the-canvas'),
        ctx = canvas.getContext('2d');

    /**
     * Get page info from document, resize canvas accordingly, and render page.
     * @param num Page number.
     */
    function renderPage(num) {
        pageRendering = true;
        // Using promise to fetch the page
        pdfDoc.getPage(num).then(function(page) {
            var viewport = page.getViewport(scale);
            canvas.height = viewport.height;
            canvas.width = viewport.width;

            // Render PDF page into canvas context
            var renderContext = {
                canvasContext: ctx,
                viewport: viewport
            };
            var renderTask = page.render(renderContext);

            // Wait for rendering to finish
            renderTask.promise.then(function() {
                pageRendering = false;
                if (pageNumPending !== null) {
                    // New page rendering is pending
                    renderPage(pageNumPending);
                    pageNumPending = null;
                }
            });
        });

        // Update page counters
        document.getElementById('page_num').textContent = pageNum;
    }

    /**
     * If another page rendering in progress, waits until the rendering is
     * finised. Otherwise, executes rendering immediately.
     */
    function queueRenderPage(num) {
        if (pageRendering) {
            pageNumPending = num;
        } else {
            renderPage(num);
        }
    }

    /**
     * Displays previous page.
     */
    function onPrevPage() {
        if (pageNum <= 1) {
            return;
        }
        pageNum--;
        queueRenderPage(pageNum);
    }
    document.getElementById('prev').addEventListener('click', onPrevPage);

    /**
     * Displays next page.
     */
    function onNextPage() {
        if (pageNum >= pdfDoc.numPages) {
            return;
        }
        pageNum++;
        queueRenderPage(pageNum);
    }
    document.getElementById('next').addEventListener('click', onNextPage);

    /**
     * Asynchronously downloads PDF.
     */
    PDFJS.getDocument(url).then(function(pdfDoc_) {
        pdfDoc = pdfDoc_;
        document.getElementById('page_count').textContent = pdfDoc.numPages;
        document.getElementById('numPages').textContent = pdfDoc.numPages;

        // Initial/first page rendering
        renderPage(pageNum);
    });

</script>
</body>
</html>

