<?php
/**
 * User: shahnuralam
 * Date: 2/6/18
 * Time: 1:11 PM
 */

namespace WPDMPP\Libs;

if (!defined('ABSPATH')) die();

class ShortCodes{

    function __construct()
    {
        add_shortcode("wpdmpp_seller_dashboard", array($this,'sellerDashboard'));
        add_shortcode( 'wpdmpp_earnings', array( $this, 'earnings' ) );
        add_shortcode( 'wpdmpp_purchases', array( $this, 'userPurchases' ) );
        add_shortcode( 'wpdmpp_guest_orders', array( $this, 'guestOrders' ) );
        add_shortcode("wpdmpp_cart", "wpdmpp_show_cart"); // function is in includes/libs/cart.php
        add_shortcode("wpdm-pp-cart", "wpdmpp_show_cart"); // function is in includes/libs/cart.php
        add_shortcode( 'wpdmpp_edit_profile' , array( $this, 'editProfile' ) );
    }

    function sellerDashboard(){
        ob_start();
        wp_register_script("wpdmpp-seller-dashboard", WPDMPP_BASE_URL.'/assets/js/Chart.js');
        include wpdm_tpl_path("wpdm-pp-seller-dashboard.php", WPDMPP_BASE_DIR.'templates/');
        return ob_get_clean();
    }

    /**
     * Function for earnings using shortcode
     */
    function earnings()
    {
        include \WPDM\Template::locate("wpdm-pp-earnings.php", WPDMPP_BASE_DIR.'templates');
    }

    /**
     * [wpdmpp_purchases] shortcode - Lists all purchases/orders made by current user
     *
     * @return string
     */
    function userPurchases()
    {
        global $current_user;

        $dashboard          = true;
        $wpdmpp_settings    = get_option('_wpdmpp_settings');

        ob_start();
        ?>
        <div class="w3eden">
        <?php
        if( ! is_user_logged_in() ) {

            // Show login/registration form. This is a Download Manager core template
            include_once( wpdm_tpl_path('wpdm-be-member.php') );

            // If guest order is enabled then show guest order page link
            if( isset($_SESSION['last_order']) && $_SESSION['last_order'] != '' && isset($wpdmpp_settings['guest_download']) && $wpdmpp_settings['guest_download'] == 1){
                include_once \WPDM\Template::locate("partials/guest_order_page_link.php", __DIR__.'/templates/');
            }
        }else{

            // List all orders made by the user
            $order = new \WPDMPP\Libs\Order();
            $myorders = $order->GetOrders($current_user->ID);

            include_once wpdm_tpl_path('wpdm-pp-purchases.php', WPDMPP_BASE_DIR.'/templates/');
        }
        echo '</div>';

        $purchase_orders_html = ob_get_clean();

        return $purchase_orders_html;
    }

    /**
     * [wpdm-pp-guest-orders] shortcode
     *
     * @return string
     */

    function guestOrders(){
        ob_start();
        global $post;

        if( get_wpdmpp_option('guest_download') != 1 )
            return 'Enable guest download from Premium Packages settings';

        if(is_object($post) && get_the_permalink() == wpdmpp_guest_order_page() && !isset($_SESSION['guest_order_init']))
            $_SESSION['guest_order_init'] = uniqid();

        include  wpdm_tpl_path('wpdm-pp-guest-orders.php', WPDMPP_BASE_DIR.'/templates/');
        return ob_get_clean();
    }

    /**
     * Edit Profile Shortcode Function
     */
    function editProfile()
    {
        include  \WPDM\Template::locate("wpdm-pp-edit-profile.php", __DIR__.'/templates/');
    }



}

new ShortCodes();