<?php
/**
 * User: shahnuralam
 * Date: 11/11/18
 * Time: 2:09 PM
 */

namespace WPDM\AddOn\lib;


class ImageWatermark
{

    var $stamp;
    var $image;
    var $left;
    var $top;
    var $opacity;
    var $filename;


    function image($image){
        $this->image = $image;
        return $this;
    }

    function stamp($stamp){
        $this->stamp = $stamp;
        return $this;
    }

    function left($left){
        $this->left = $left;
        return $this;
    }

    function top($top){
        $this->top = $top;
        return $this;
    }

    function opacity($opacity){
        $this->opacity = $opacity;
        return $this;
    }

    function filename($filename){
        $this->filename = $filename;
        return $this;
    }


    function apply()
    {

        if(!file_exists(WPDM_CACHE_DIR.'watermarked/'))
            mkdir(WPDM_CACHE_DIR.'watermarked/', 0755);

        $result = WPDM_CACHE_DIR.'watermarked/'.uniqid()."__".$this->filename.'.png';
        //wpdmdd($this->stamp);
        // Load the stamp and the photo to apply the watermark to
        if(stristr($this->stamp, ".png"))
            $stamp = imagecreatefrompng($this->stamp);
        if(stristr($this->stamp, ".gif"))
            $stamp = imagecreatefromgif($this->stamp);
        if(stristr($this->stamp, ".jpg") || stristr($this->stamp, ".jpeg"))
            $stamp = imagecreatefromjpeg($this->stamp);

       //wpdmdd($this->image);
        if(stristr($this->image, ".png"))
            $im = imagecreatefrompng($this->image);
        if(stristr($this->image, ".gif"))
            $im = imagecreatefromgif($this->image);
        if(stristr($this->image, ".jpg") || stristr($this->image, ".jpeg"))
            $im = imagecreatefromjpeg($this->image);
        //$im = imagecreatefromjpeg($this->image);

        // Set the margins for the stamp and get the height/width of the stamp image
        $posx = $this->left;
        $posy = $this->top;
        $sx = imagesx($stamp);
        $sy = imagesy($stamp);
        //270x180
        //if($sx < 256) $posx += (int)((256 - $sx)/2);
        //if($sy < 256) $posy += (int)((256 - $sy)/2);

        // Copy the stamp image onto our photo using the margin offsets and the photo
        // width to calculate positioning of the stamp.
        imagecopy($im, $stamp, $posx, $posy, 0, 0, imagesx($stamp), imagesy($stamp));

        // Output and free memory

        imagepng($im, $result);
        imagedestroy($im);

        return $result;
    }

}
